'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactScrollbarsCustom = require('react-scrollbars-custom');

var _reactScrollbarsCustom2 = _interopRequireDefault(_reactScrollbarsCustom);

var _scrollUtils = require('./utils/scrollUtils');

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

var _RowsContainer = require('./RowsContainer');

var _RowsContainer2 = _interopRequireDefault(_RowsContainer);

var _RowGroup = require('./RowGroup');

var _RowGroup2 = _interopRequireDefault(_RowGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var joinClasses = require('classnames');

var Row = require('./Row');
var cellMetaDataShape = require('./PropTypeShapes/CellMetaDataShape');
var RowUtils = require('./RowUtils');


require('./themes/react-data-grid-core.css');

var Canvas = (_temp2 = _class = function (_React$Component) {
  _inherits(Canvas, _React$Component);

  function Canvas() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Canvas);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Canvas.__proto__ || Object.getPrototypeOf(Canvas)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      displayStart: _this.props.displayStart,
      displayEnd: _this.props.displayEnd,
      scrollingTimeout: null
    }, _this._currentRowsLength = 0, _this._currentRowsRange = { start: 0, end: 0 }, _this._scroll = { scrollTop: 0, scrollLeft: 0 }, _this.appendScrollShim = function () {
      if (!_this._scrollShim) {
        var size = _this._scrollShimSize();
        var shim = (0, _scrollUtils.createScrollShim)(size);
        _this.canvas.appendChild(shim);
        _this._scrollShim = shim;
      }
      _this._scheduleRemoveScrollShim();
    }, _this._scrollShimSize = function () {
      return {
        width: _this.props.width,
        height: _this.props.length * _this.props.rowHeight
      };
    }, _this._scheduleRemoveScrollShim = function () {
      if (_this._scheduleRemoveScrollShimTimer) {
        clearTimeout(_this._scheduleRemoveScrollShimTimer);
      }
      _this._scheduleRemoveScrollShimTimer = setTimeout(_this._removeScrollShim, 200);
    }, _this._removeScrollShim = function () {
      if (_this._scrollShim) {
        _this._scrollShim.parentNode.removeChild(_this._scrollShim);
        _this._scrollShim = undefined;
      }
    }, _this.onRows = function () {
      if (_this._currentRowsRange !== { start: 0, end: 0 }) {
        _this.props.onRows(_this._currentRowsRange);
        _this._currentRowsRange = { start: 0, end: 0 };
      }
    }, _this.onScroll = function (e, x, y, z) {
      if (e.scrollWidth != x.scrollWidth) {
        _this.canvas.scrollTo(x.scrollTop, x.scrollLeft);
        return;
      }
      /* if (this.canvas !== e.target) {
         return;
       }*/
      //this.appendScrollShim();
      var scrollLeft = e.scrollLeft;
      var scrollTop = e.scrollTop;
      var scroll = { scrollTop: scrollTop, scrollLeft: scrollLeft };
      _this._scroll = scroll;
      _this.props.onScroll(scroll);
    }, _this.getRows = function (displayStart, displayEnd) {
      _this._currentRowsRange = { start: displayStart, end: displayEnd };
      if (Array.isArray(_this.props.rowGetter)) {
        return _this.props.rowGetter.slice(displayStart, displayEnd);
      }
      var rows = [];
      var i = displayStart;
      while (i < displayEnd) {
        var row = _this.props.rowGetter(i);
        var subRowDetails = {};
        if (_this.props.getSubRowDetails) {
          subRowDetails = _this.props.getSubRowDetails(row);
        }
        rows.push({ row: row, subRowDetails: subRowDetails });
        i++;
      }
      return rows;
    }, _this.getScrollbarWidth = function () {
      // Get the scrollbar width
      var scrollbarWidth = _this.canvas.offsetWidth - _this.canvas.clientWidth;
      return scrollbarWidth;
    }, _this.getScroll = function () {
      var _this$canvas = _this.canvas,
          scrollTop = _this$canvas.scrollTop,
          scrollLeft = _this$canvas.scrollLeft;

      return { scrollTop: scrollTop, scrollLeft: scrollLeft };
    }, _this.isRowSelected = function (idx, row) {
      // Use selectedRows if set
      if (_this.props.selectedRows !== null) {
        var selectedRows = _this.props.selectedRows.filter(function (r) {
          var rowKeyValue = row.get ? row.get(_this.props.rowKey) : row[_this.props.rowKey];
          return r[_this.props.rowKey] === rowKeyValue;
        });
        return selectedRows.length > 0 && selectedRows[0].isSelected;
      }

      // Else use new rowSelection props
      if (_this.props.rowSelection) {
        var _this$props$rowSelect = _this.props.rowSelection,
            keys = _this$props$rowSelect.keys,
            indexes = _this$props$rowSelect.indexes,
            isSelectedKey = _this$props$rowSelect.isSelectedKey;

        return RowUtils.isRowSelected(keys, indexes, isSelectedKey, row, idx);
      }

      return false;
    }, _this.setScrollLeft = function (scrollLeft) {
      if (_this._currentRowsLength !== 0) {
        if (!_this.rows) return;
        for (var i = 0, len = _this._currentRowsLength; i < len; i++) {
          if (_this.rows[i]) {
            var row = _this.getRowByRef(i);
            if (row && row.setScrollLeft) {
              row.setScrollLeft(scrollLeft);
            }
          }
        }
      }
      var scroll = { scrollTop: _this._scroll.scrollTop, scrollLeft: scrollLeft };
      _this.canvas.scrollTo(_this._scroll.scrollTop, scrollLeft);

      _this._scroll = scroll;
      _this.props.onScroll(scroll);
    }, _this.scrollToTop = function () {
      _this._scroll.scrollTop = 0;
    }, _this.getRowByRef = function (i) {
      // check if wrapped with React DND drop target
      var wrappedRow = _this.rows[i].getDecoratedComponentInstance ? _this.rows[i].getDecoratedComponentInstance(i) : null;
      if (wrappedRow) {
        return wrappedRow.row;
      }
      return _this.rows[i];
    }, _this.renderRow = function (props) {
      var row = props.row;
      if (row.__metaData && row.__metaData.getRowRenderer) {
        return row.__metaData.getRowRenderer(_this.props, props.idx);
      }
      if (row.__metaData && row.__metaData.isGroup) {
        return React.createElement(_RowGroup2['default'], _extends({}, props, row.__metaData, {
          name: row.name,
          renderer: _this.props.rowGroupRenderer }));
      }
      var RowsRenderer = _this.props.rowRenderer;
      if (typeof RowsRenderer === 'function') {
        return React.createElement(RowsRenderer, props);
      }

      if (React.isValidElement(_this.props.rowRenderer)) {
        return React.cloneElement(_this.props.rowRenderer, props);
      }
    }, _this.renderPlaceholder = function (key, height) {
      // just renders empty cells
      // if we wanted to show gridlines, we'd need classes and position as with renderScrollingPlaceholder
      return React.createElement(
        'div',
        { key: key, style: { height: height } },
        _this.props.columns.map(function (column, idx) {
          return React.createElement('div', { style: { width: column.width }, key: idx });
        })
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Canvas, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.rows = [];
      this._currentRowsLength = 0;
      this._currentRowsRange = { start: 0, end: 0 };
      this._scroll = { scrollTop: 0, scrollLeft: 0 };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.onRows();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.displayStart !== this.state.displayStart || nextProps.displayEnd !== this.state.displayEnd) {
        this.setState({
          displayStart: nextProps.displayStart,
          displayEnd: nextProps.displayEnd
        });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var shouldUpdate = nextState.displayStart !== this.state.displayStart || nextState.displayEnd !== this.state.displayEnd || nextState.scrollingTimeout !== this.state.scrollingTimeout || this.props.scrollToRowIndex !== nextProps.scrollToRowIndex || nextProps.rowsCount !== this.props.rowsCount || nextProps.rowHeight !== this.props.rowHeight || nextProps.columns !== this.props.columns || nextProps.width !== this.props.width || nextProps.height !== this.props.height || nextProps.cellMetaData !== this.props.cellMetaData || this.props.colDisplayStart !== nextProps.colDisplayStart || this.props.colDisplayEnd !== nextProps.colDisplayEnd || this.props.colVisibleStart !== nextProps.colVisibleStart || this.props.colVisibleEnd !== nextProps.colVisibleEnd || !(0, _shallowequal2['default'])(nextProps.style, this.props.style) || this.props.isScrolling !== nextProps.isScrolling;
      return shouldUpdate;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this._currentRowsLength = 0;
      this._currentRowsRange = { start: 0, end: 0 };
      this._scroll = { scrollTop: 0, scrollLeft: 0 };
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this._scroll.scrollTop !== 0 && this._scroll.scrollLeft !== 0) {
        this.setScrollLeft(this._scroll.scrollLeft);
      }
      if (this.props.scrollToRowIndex !== 0) {
        this.canvas.scrollTop = Math.min(this.props.scrollToRowIndex * this.props.rowHeight, this.props.rowsCount * this.props.rowHeight - this.props.height);
      }
      this.onRows();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _state = this.state,
          displayStart = _state.displayStart,
          displayEnd = _state.displayEnd;
      var _props = this.props,
          rowHeight = _props.rowHeight,
          rowsCount = _props.rowsCount;


      var rows = this.getRows(displayStart, displayEnd).map(function (r, idx) {
        return _this2.renderRow({
          key: 'row-' + (displayStart + idx),
          ref: function ref(node) {
            return _this2.rows[idx] = node;
          },
          idx: displayStart + idx,
          visibleStart: _this2.props.visibleStart,
          visibleEnd: _this2.props.visibleEnd,
          row: r.row,
          height: rowHeight,
          onMouseOver: _this2.onMouseOver,
          columns: _this2.props.columns,
          isSelected: _this2.isRowSelected(displayStart + idx, r.row, displayStart, displayEnd),
          expandedRows: _this2.props.expandedRows,
          cellMetaData: _this2.props.cellMetaData,
          subRowDetails: r.subRowDetails,
          colVisibleStart: _this2.props.colVisibleStart,
          colVisibleEnd: _this2.props.colVisibleEnd,
          colDisplayStart: _this2.props.colDisplayStart,
          colDisplayEnd: _this2.props.colDisplayEnd,
          isScrolling: _this2.props.isScrolling
        });
      });

      this._currentRowsLength = rows.length;

      if (displayStart > 0) {
        rows.unshift(this.renderPlaceholder('top', displayStart * rowHeight));
      }

      if (rowsCount - displayEnd > 0) {
        rows.push(this.renderPlaceholder('bottom', (rowsCount - displayEnd) * rowHeight));
      }

      var style = {
        position: 'absolute',
        top: 0,
        left: 0,
        //overflowX: 'auto',
        //overflowY: 'scroll',
        width: this.props.totalWidth,
        height: this.props.height
      };
      var topFilters = this._scroll.scrollTop;
      var scrollLeft = this._scroll.scrollLeft;
      return React.createElement(
        _reactScrollbarsCustom2['default'],
        {
          ref: function ref(div) {
            _this2.canvas = div;
          },
          native: false,
          scrollLeft: scrollLeft,
          scrollTop: topFilters,
          style: style,
          onScroll: this.onScroll,
          className: joinClasses('react-grid-Canvas', this.props.className, { opaque: this.props.cellMetaData.selected && this.props.cellMetaData.selected.active }) },
        React.createElement(_RowsContainer2['default'], {
          ref: function ref(node) {
            _this2.container = node;
          },
          width: this.props.width,
          rows: rows,
          topFilters: topFilters,
          columns: this.props.columns,
          contextMenu: this.props.contextMenu,
          rowIdx: this.props.cellMetaData.selected.rowIdx,
          idx: this.props.cellMetaData.selected.idx })
      );
    }
  }]);

  return Canvas;
}(React.Component), _class.displayName = 'Canvas', _class.defaultProps = {
  rowRenderer: Row,
  onRows: function onRows() {},
  selectedRows: [],
  rowScrollTimeout: 0
}, _temp2);
Canvas.propTypes = process.env.NODE_ENV !== "production" ? {
  rowRenderer: _propTypes2['default'].oneOfType([_propTypes2['default'].func, _propTypes2['default'].element]),
  rowHeight: _propTypes2['default'].number.isRequired,
  height: _propTypes2['default'].number.isRequired,
  width: _propTypes2['default'].number,
  totalWidth: _propTypes2['default'].oneOfType([_propTypes2['default'].number, _propTypes2['default'].string]),
  style: _propTypes2['default'].string,
  className: _propTypes2['default'].string,
  displayStart: _propTypes2['default'].number.isRequired,
  displayEnd: _propTypes2['default'].number.isRequired,
  visibleStart: _propTypes2['default'].number.isRequired,
  visibleEnd: _propTypes2['default'].number.isRequired,
  colVisibleStart: _propTypes2['default'].number.isRequired,
  colVisibleEnd: _propTypes2['default'].number.isRequired,
  colDisplayStart: _propTypes2['default'].number.isRequired,
  colDisplayEnd: _propTypes2['default'].number.isRequired,
  rowsCount: _propTypes2['default'].number.isRequired,
  rowGetter: _propTypes2['default'].oneOfType([_propTypes2['default'].func.isRequired, _propTypes2['default'].array.isRequired]),
  expandedRows: _propTypes2['default'].array,
  onRows: _propTypes2['default'].func,
  onScroll: _propTypes2['default'].func,
  columns: _propTypes2['default'].oneOfType([_propTypes2['default'].object, _propTypes2['default'].array]).isRequired,
  cellMetaData: _propTypes2['default'].shape(cellMetaDataShape).isRequired,
  selectedRows: _propTypes2['default'].array,
  rowKey: _propTypes2['default'].string,
  rowScrollTimeout: _propTypes2['default'].number,
  scrollToRowIndex: _propTypes2['default'].number,
  contextMenu: _propTypes2['default'].element,
  getSubRowDetails: _propTypes2['default'].func,
  rowSelection: _propTypes2['default'].oneOfType([_propTypes2['default'].shape({
    indexes: _propTypes2['default'].arrayOf(_propTypes2['default'].number).isRequired
  }), _propTypes2['default'].shape({
    isSelectedKey: _propTypes2['default'].string.isRequired
  }), _propTypes2['default'].shape({
    keys: _propTypes2['default'].shape({
      values: _propTypes2['default'].array.isRequired,
      rowKey: _propTypes2['default'].string.isRequired
    }).isRequired
  })]),
  rowGroupRenderer: _propTypes2['default'].func,
  isScrolling: _propTypes2['default'].bool,
  length: _propTypes2['default'].number
} : {};


module.exports = Canvas;