'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var ChildRowDeleteButton = function ChildRowDeleteButton(_ref) {
  var treeDepth = _ref.treeDepth,
      cellHeight = _ref.cellHeight,
      siblingIndex = _ref.siblingIndex,
      numberSiblings = _ref.numberSiblings,
      onDeleteSubRow = _ref.onDeleteSubRow,
      isDeleteSubRowEnabled = _ref.isDeleteSubRowEnabled,
      _ref$allowAddChildRow = _ref.allowAddChildRow,
      allowAddChildRow = _ref$allowAddChildRow === undefined ? true : _ref$allowAddChildRow;

  var lastSibling = siblingIndex === numberSiblings - 1;
  var className = (0, _classnames2['default'])({ 'rdg-child-row-action-cross': allowAddChildRow === true || !lastSibling }, { 'rdg-child-row-action-cross-last': allowAddChildRow === false && (lastSibling || numberSiblings === 1) });
  var height = 12;
  var width = 12;
  var left = treeDepth * 15;
  var top = (cellHeight - 12) / 2;
  return _react2['default'].createElement(
    'div',
    null,
    _react2['default'].createElement('div', { className: className }),
    isDeleteSubRowEnabled && _react2['default'].createElement(
      'div',
      { style: { left: left, top: top, width: width, height: height }, className: 'rdg-child-row-btn', onClick: onDeleteSubRow },
      _react2['default'].createElement('div', { className: 'glyphicon glyphicon-remove-sign' })
    )
  );
};

exports['default'] = ChildRowDeleteButton;