'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var ReactDOM = require('react-dom');


var Header = require('./Header');
var Viewport = require('./Viewport');
var cellMetaDataShape = require('./PropTypeShapes/CellMetaDataShape');
var SortableHeaderCell = require('./cells/headerCells/SortableHeaderCell');
var SortDataShape = require('./PropTypeShapes/SortDataShape');
require('./themes/react-data-grid-core.css');

var Grid = (_temp2 = _class = function (_React$Component) {
  _inherits(Grid, _React$Component);

  function Grid() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Grid);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Grid.__proto__ || Object.getPrototypeOf(Grid)).call.apply(_ref, [this].concat(args))), _this), _this.getStyle = function () {
      return {
        overflow: 'hidden',
        outline: 0,
        position: 'relative',
        minHeight: _this.props.minHeight
      };
    }, _this._onScroll = function () {
      if (_this._scrollLeft !== undefined) {
        _this.header.setScrollLeft(_this._scrollLeft);
        if (_this.viewport) {
          _this.viewport.setScrollLeft(_this._scrollLeft);
        }
      }
    }, _this.onScroll = function (props) {
      if (_this._scrollLeft !== props.scrollLeft) {
        _this._scrollLeft = props.scrollLeft;
        _this._onScroll();
      }
    }, _this.showFilterCallback = function (column) {
      _this.viewport.showFilter(column);
    }, _this.setAppliedFilters = function (filters) {
      _this.header.setAppliedFilters(filters);
    }, _this.onHeaderScroll = function (e) {
      var scrollLeft = e.target.scrollLeft;
      if (_this._scrollLeft !== scrollLeft) {
        _this._scrollLeft = scrollLeft;
        _this.header.setScrollLeft(scrollLeft);
        var canvas = ReactDOM.findDOMNode(_this.viewport.canvas);
        canvas.scrollLeft = scrollLeft;
        _this.viewport.canvas.setScrollLeft(scrollLeft);
      }
    }, _this.onColumnResize = function (index, width, totalWidth) {
      return _this.props.onColumnResize(index, width, _this._scrollLeft, totalWidth);
    }, _this.onHeaderDrop = function (e, x, y) {
      _this.props.onHeaderDrop(e, x, y);
      _this.viewport.canvas.setScrollLeft(_this._scrollLeft);
    }, _this.scrollToTop = function () {
      _this.viewport.scrollToTop();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Grid, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._scrollLeft = this.viewport ? this.viewport.getScroll().scrollLeft : 0;
      this._onScroll();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this._onScroll();
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this._scrollLeft = undefined;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this._scrollLeft = undefined;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var headerRows = this.props.headerRows || [{ ref: function ref(node) {
          return _this2.row = node;
        } }];
      var EmptyRowsView = this.props.emptyRowsView;

      return React.createElement(
        'div',
        { style: this.getStyle(), className: 'react-grid-Grid' },
        React.createElement(Header, {
          ref: function ref(input) {
            _this2.header = input;
          },
          columnMetrics: this.props.columnMetrics,
          onColumnResize: this.onColumnResize,
          height: this.props.rowHeight,
          totalWidth: this.props.totalWidth,
          headerRows: headerRows,
          sortColumn: this.props.sortColumn,
          sortDirection: this.props.sortDirection,
          draggableHeaderCell: this.props.draggableHeaderCell,
          sort: this.props.sort,
          onSort: this.props.onSort,
          onHeaderDrop: this.onHeaderDrop,
          onScroll: this.onHeaderScroll,
          getValidFilterValues: this.props.getValidFilterValues,
          cellMetaData: this.props.cellMetaData,
          showFilterCallback: this.showFilterCallback
        }),
        this.props.rowsCount >= 1 || this.props.rowsCount === 0 && !this.props.emptyRowsView ? React.createElement(
          'div',
          {
            ref: function ref(node) {
              _this2.viewPortContainer = node;
            },
            tabIndex: this.props.tabIndex,
            onKeyDown: this.props.onViewportKeydown,
            onKeyUp: this.props.onViewportKeyup,
            onClick: this.props.onViewportClick,
            onDoubleClick: this.props.onViewportDoubleClick,
            onDragStart: this.props.onViewportDragStart,
            onDragEnd: this.props.onViewportDragEnd },
          React.createElement(Viewport, {
            ref: function ref(node) {
              _this2.viewport = node;
            },
            headerHeight: this.props.headerRowHeight,
            rowKey: this.props.rowKey,
            width: this.props.columnMetrics.width,
            rowHeight: this.props.rowHeight,
            rowRenderer: this.props.rowRenderer,
            rowGetter: this.props.rowGetter,
            rowsCount: this.props.rowsCount,
            selectedRows: this.props.selectedRows,
            expandedRows: this.props.expandedRows,
            columnMetrics: this.props.columnMetrics,
            totalWidth: this.props.totalWidth,
            onScroll: this.onScroll,
            onRows: this.props.onRows,
            cellMetaData: this.props.cellMetaData,
            rowOffsetHeight: this.props.rowOffsetHeight || this.props.rowHeight * headerRows.length,
            minHeight: this.props.minHeight,
            rowScrollTimeout: this.props.rowScrollTimeout,
            scrollToRowIndex: this.props.scrollToRowIndex,
            contextMenu: this.props.contextMenu,
            rowSelection: this.props.rowSelection,
            getSubRowDetails: this.props.getSubRowDetails,
            rowGroupRenderer: this.props.rowGroupRenderer,
            overScan: this.props.overScan,
            dataReady: this.props.dataReady,
            loadingElementRender: this.props.loadingElementRender
          })
        ) : React.createElement(
          'div',
          { ref: function ref(node) {
              _this2.emptyView = node;
            }, className: 'react-grid-Empty' },
          React.createElement(EmptyRowsView, null)
        )
      );
    }
  }]);

  return Grid;
}(React.Component), _class.displayName = 'Grid', _class.defaultProps = {
  rowHeight: 35,
  minHeight: 350,
  tabIndex: 0
}, _temp2);
Grid.propTypes = process.env.NODE_ENV !== "production" ? {
  rowGetter: _propTypes2['default'].oneOfType([_propTypes2['default'].array, _propTypes2['default'].func]).isRequired,
  columns: _propTypes2['default'].oneOfType([_propTypes2['default'].array, _propTypes2['default'].object]),
  tabIndex: _propTypes2['default'].number,
  columnMetrics: _propTypes2['default'].object,
  minHeight: _propTypes2['default'].number,
  totalWidth: _propTypes2['default'].oneOfType([_propTypes2['default'].number, _propTypes2['default'].string]),
  headerRows: _propTypes2['default'].oneOfType([_propTypes2['default'].array, _propTypes2['default'].func]),
  rowHeight: _propTypes2['default'].number,
  rowRenderer: _propTypes2['default'].oneOfType([_propTypes2['default'].element, _propTypes2['default'].func]),
  emptyRowsView: _propTypes2['default'].func,
  expandedRows: _propTypes2['default'].oneOfType([_propTypes2['default'].array, _propTypes2['default'].func]),
  selectedRows: _propTypes2['default'].oneOfType([_propTypes2['default'].array, _propTypes2['default'].func]),
  rowSelection: _propTypes2['default'].oneOfType([_propTypes2['default'].shape({
    indexes: _propTypes2['default'].arrayOf(_propTypes2['default'].number).isRequired
  }), _propTypes2['default'].shape({
    isSelectedKey: _propTypes2['default'].string.isRequired
  }), _propTypes2['default'].shape({
    keys: _propTypes2['default'].shape({
      values: _propTypes2['default'].array.isRequired,
      rowKey: _propTypes2['default'].string.isRequired
    }).isRequired
  })]),
  rowsCount: _propTypes2['default'].number,
  onRows: _propTypes2['default'].func,
  sortColumn: _propTypes2['default'].string,
  sortDirection: _propTypes2['default'].oneOf(Object.keys(SortableHeaderCell.DEFINE_SORT)),
  sort: SortDataShape,
  rowOffsetHeight: _propTypes2['default'].number.isRequired,
  onViewportKeydown: _propTypes2['default'].func.isRequired,
  onViewportKeyup: _propTypes2['default'].func,
  onViewportDragStart: _propTypes2['default'].func.isRequired,
  onViewportDragEnd: _propTypes2['default'].func.isRequired,
  onViewportClick: _propTypes2['default'].func.isRequired,
  onViewportDoubleClick: _propTypes2['default'].func.isRequired,
  onColumnResize: _propTypes2['default'].func,
  onSort: _propTypes2['default'].func,
  onHeaderDrop: _propTypes2['default'].func,
  cellMetaData: _propTypes2['default'].shape(cellMetaDataShape),
  rowKey: _propTypes2['default'].string.isRequired,
  rowScrollTimeout: _propTypes2['default'].number,
  scrollToRowIndex: _propTypes2['default'].number,
  contextMenu: _propTypes2['default'].element,
  getSubRowDetails: _propTypes2['default'].func,
  draggableHeaderCell: _propTypes2['default'].func,
  getValidFilterValues: _propTypes2['default'].func,
  rowGroupRenderer: _propTypes2['default'].func,
  overScan: _propTypes2['default'].object,
  dataReady: _propTypes2['default'].bool
} : {};


module.exports = Grid;