'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OverflowCellComponent = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _focusableComponentWrapper = require('./focusableComponentWrapper');

var _focusableComponentWrapper2 = _interopRequireDefault(_focusableComponentWrapper);

require('./themes/react-data-grid-cell.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var OverflowCell = function (_React$Component) {
  _inherits(OverflowCell, _React$Component);

  function OverflowCell() {
    _classCallCheck(this, OverflowCell);

    return _possibleConstructorReturn(this, (OverflowCell.__proto__ || Object.getPrototypeOf(OverflowCell)).apply(this, arguments));
  }

  _createClass(OverflowCell, [{
    key: 'getStyle',
    value: function getStyle() {
      var style = {
        position: 'absolute',
        width: this.props.column.width,
        height: this.props.height,
        left: this.props.column.left,
        border: '1px solid #eee'
      };
      return style;
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2['default'].createElement('div', { tabIndex: '-1', style: this.getStyle(), width: '100%', className: 'react-grid-Cell' });
    }
  }]);

  return OverflowCell;
}(_react2['default'].Component);

OverflowCell.isSelected = function (props) {
  var cellMetaData = props.cellMetaData,
      rowIdx = props.rowIdx,
      idx = props.idx;

  if (cellMetaData == null) {
    return false;
  }

  var selected = cellMetaData.selected;


  return selected && selected.rowIdx === rowIdx && selected.idx === idx;
};

OverflowCell.isScrolling = function (props) {
  return props.cellMetaData.isScrollingHorizontallyWithKeyboard;
};

OverflowCell.propTypes = process.env.NODE_ENV !== "production" ? {
  rowIdx: _propTypes2['default'].number,
  idx: _propTypes2['default'].number,
  height: _propTypes2['default'].number,
  column: _propTypes2['default'].object,
  cellMetaData: _propTypes2['default'].object
} : {};

OverflowCell.displayName = 'Cell';

var OverflowCellComponent = OverflowCell;
exports['default'] = (0, _focusableComponentWrapper2['default'])(OverflowCell);
exports.OverflowCellComponent = OverflowCellComponent;