'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp, _initialiseProps;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _SelectAll = require('./formatters/SelectAll');

var _SelectAll2 = _interopRequireDefault(_SelectAll);

var _AppConstants = require('./AppConstants');

var _AppConstants2 = _interopRequireDefault(_AppConstants);

var _SortableHeaderCell = require('./cells/headerCells/SortableHeaderCell');

var _keyboardUtils = require('./utils/keyboardUtils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');

var BaseGrid = require('./Grid');
var CheckboxEditor = require('./editors/CheckboxEditor');
var RowUtils = require('./RowUtils');
var ColumnUtils = require('./ColumnUtils');
var KeyCodes = require('./KeyCodes');
var isFunction = require('./utils/isFunction');
var SortDataShape = require('./PropTypeShapes/SortDataShape');

var ColumnMetrics = require('./ColumnMetrics');
require('./themes/react-data-grid-core.css');
require('./themes/react-data-grid-checkbox.css');
var SortableHeaderCell = require('./cells/headerCells/SortableHeaderCell');

if (!Object.assign) {
    Object.assign = require('object-assign');
}

var ReactDataGrid = (_temp = _class = function (_React$Component) {
    _inherits(ReactDataGrid, _React$Component);

    function ReactDataGrid(props, context) {
        _classCallCheck(this, ReactDataGrid);

        var _this = _possibleConstructorReturn(this, (ReactDataGrid.__proto__ || Object.getPrototypeOf(ReactDataGrid)).call(this, props, context));

        _initialiseProps.call(_this);

        var columnMetrics = _this.createColumnMetrics();
        var initialState = {
            columnMetrics: columnMetrics,
            selectedRows: [],
            copied: null,
            expandedRows: [],
            canFilter: false,
            columnFilters: {},
            sortDirection: null,
            sortColumn: null,
            dragged: null,
            scrollOffset: 0,
            lastRowIdxUiSelected: -1
        };
        if (props.enableCellSelect) {
            initialState.selected = { rowIdx: 0, idx: 0 };
        } else {
            initialState.selected = { rowIdx: -1, idx: -1 };
        }
        if (_this.props.multipleColumnsSort) {
            initialState.sort = _this.props.sort || [];
        }

        if (_this.props.sortColumn && _this.props.sortDirection) {
            initialState.sortColumn = _this.props.sortColumn;
            initialState.sortDirection = _this.props.sortDirection;
        }

        _this.state = initialState;
        return _this;
    }

    _createClass(ReactDataGrid, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this._mounted = true;
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (window.addEventListener) {
                window.addEventListener('resize', this.metricsUpdated);
            } else {
                window.attachEvent('resize', this.metricsUpdated);
            }
            this.metricsUpdated();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this._mounted = false;
            window.removeEventListener('resize', this.metricsUpdated);
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.columns) {
                if (!ColumnMetrics.sameColumns(this.props.columns, nextProps.columns, this.props.columnEquality) || nextProps.minWidth !== this.props.minWidth) {
                    var columnMetrics = this.createColumnMetrics(nextProps);
                    var fullWidth = columnMetrics.width;
                    /*for (let i = 0; i < this.state.columnMetrics.columns.length; i++) {
                      fullWidth += this.state.columnMetrics.columns[i].width;
                    }*/
                    var needResizeLast = false;
                    var lastColumnWidth = 0;
                    if (fullWidth < columnMetrics.totalWidth && fullWidth != 0) {
                        needResizeLast = true;
                        lastColumnWidth = columnMetrics.columns[columnMetrics.columns.length - 1].width + columnMetrics.totalWidth - fullWidth - 10;
                        columnMetrics = ColumnMetrics.resizeColumn(columnMetrics, columnMetrics.columns.length - 1, lastColumnWidth);
                    }
                    //this.props.columns[index].width = width;

                    this.setState({ columnMetrics: columnMetrics });
                    if (needResizeLast === true && fullWidth != 0) {
                        this.props.onColumnResize(columnMetrics.columns.length - 1, lastColumnWidth, 0);
                    }
                }
            }
        }

        //if (totalWidth > this.props.rowsContainerWidth) {
        //this.props.column.width += TotalWidth - this.props.rowsContainerWidth / this.props.columns.length - 1;
        //}

        // return false if not a shift select so can be handled as normal row selection


        // columnKey not used here as this function will select the whole row,
        // but needed to match the function signature in the CheckboxEditor

    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var cellMetaData = {
                rowKey: this.props.rowKey,
                selected: this.state.selected,
                dragged: this.state.dragged,
                hoveredRowIdx: this.state.hoveredRowIdx,
                onCellClick: this.onCellClick,
                onCellFocus: this.onCellFocus,
                onCellContextMenu: this.onCellContextMenu,
                onCellDoubleClick: this.onCellDoubleClick,
                onCommit: this.onCellCommit,
                onCommitCancel: this.setInactive,
                copied: this.state.copied,
                handleDragEnterRow: this.handleDragEnter,
                handleTerminateDrag: this.handleTerminateDrag,
                enableCellSelect: this.props.enableCellSelect,
                onColumnEvent: this.onColumnEvent,
                openCellEditor: this.openCellEditor,
                onDragHandleDoubleClick: this.onDragHandleDoubleClick,
                onCellExpand: this.onCellExpand,
                onRowExpandToggle: this.onRowExpandToggle,
                onRowHover: this.onRowHover,
                getDataGridDOMNode: this.getDataGridDOMNode,
                getCellActions: this.props.getCellActions,
                onDeleteSubRow: this.props.onDeleteSubRow,
                onAddSubRow: this.props.onAddSubRow,
                isScrollingVerticallyWithKeyboard: this.isKeyDown(KeyCodes.DownArrow) || this.isKeyDown(KeyCodes.UpArrow),
                isScrollingHorizontallyWithKeyboard: this.isKeyDown(KeyCodes.LeftArrow) || this.isKeyDown(KeyCodes.RightArrow) || this.isKeyDown(KeyCodes.Tab),
                enableCellAutoFocus: this.props.enableCellAutoFocus
            };

            var toolbar = this.renderToolbar();
            var containerWidth = this.props.minWidth || this.gridWidth();
            var gridWidth = containerWidth - this.state.scrollOffset;

            // depending on the current lifecycle stage, gridWidth() may not initialize correctly
            // this also handles cases where it always returns undefined -- such as when inside a div with display:none
            // eg Bootstrap tabs and collapses
            if (typeof containerWidth === 'undefined' || isNaN(containerWidth) || containerWidth === 0) {
                containerWidth = '100%';
            }
            if (typeof gridWidth === 'undefined' || isNaN(gridWidth) || gridWidth === 0) {
                gridWidth = '100%';
            }
            return React.createElement(
                'div',
                { className: 'react-grid-Container', style: { width: containerWidth },
                    ref: function ref(node) {
                        _this2.grid = node;
                    } },
                toolbar,
                React.createElement(
                    'div',
                    { className: 'react-grid-Main' },
                    React.createElement(BaseGrid, _extends({
                        ref: function ref(node) {
                            return _this2.base = node;
                        }
                    }, this.props, {
                        rowKey: this.props.rowKey,
                        headerRows: this.getHeaderRows(),
                        columnMetrics: this.state.columnMetrics,
                        rowGetter: this.props.rowGetter,
                        rowsCount: this.props.rowsCount,
                        rowHeight: this.props.rowHeight,
                        cellMetaData: cellMetaData,
                        selectedRows: this.getSelectedRows(),
                        rowSelection: this.getRowSelectionProps(),
                        expandedRows: this.state.expandedRows,
                        rowOffsetHeight: this.getRowOffsetHeight(),
                        sortColumn: this.state.sortColumn,
                        sortDirection: this.state.sortDirection,
                        sort: this.state.sort,
                        onSort: this.handleSort,
                        minHeight: this.props.minHeight,
                        totalWidth: gridWidth,
                        onViewportKeydown: this.onKeyDown,
                        onViewportKeyup: this.onKeyUp,
                        onViewportDragStart: this.onDragStart,
                        onViewportDragEnd: this.handleDragEnd,
                        onViewportClick: this.deselect,
                        onViewportDoubleClick: this.deselect,
                        onColumnResize: this.onColumnResize,
                        rowScrollTimeout: this.props.rowScrollTimeout,
                        scrollToRowIndex: this.props.scrollToRowIndex,
                        contextMenu: this.props.contextMenu,
                        overScan: this.props.overScan }))
                )
            );
        }
    }]);

    return ReactDataGrid;
}(React.Component), _class.displayName = 'ReactDataGrid', _class.defaultProps = {
    enableCellSelect: false,
    tabIndex: -1,
    rowHeight: 35,
    headerFiltersHeight: 45,
    enableRowSelect: false,
    minHeight: 350,
    rowKey: 'id',
    rowScrollTimeout: 0,
    scrollToRowIndex: 0,
    cellNavigationMode: 'none',
    overScan: {
        colsStart: 5,
        colsEnd: 5,
        rowsStart: 5,
        rowsEnd: 5
    },
    enableCellAutoFocus: true,
    onBeforeEdit: function onBeforeEdit() {},
    minColumnWidth: 80,
    columnEquality: ColumnMetrics.sameColumn
}, _initialiseProps = function _initialiseProps() {
    var _this3 = this;

    this.gridWidth = function () {
        return _this3.grid ? _this3.grid.parentElement.offsetWidth : 0;
    };

    this.getTotalWidth = function () {
        var totalWidth = 0;
        if (_this3._mounted) {
            totalWidth = _this3.gridWidth();
        } else {
            totalWidth = ColumnUtils.getSize(_this3.props.columns) * _this3.props.minColumnWidth;
        }
        return totalWidth;
    };

    this.getColumnMetricsType = function (metrics) {
        var totalWidth = metrics.totalWidth || _this3.getTotalWidth();
        var currentMetrics = {
            columns: metrics.columns,
            totalWidth: totalWidth,
            minColumnWidth: metrics.minColumnWidth
        };
        var updatedMetrics = ColumnMetrics.recalculate(currentMetrics);
        return updatedMetrics;
    };

    this.getColumn = function (idx) {
        var columns = _this3.state.columnMetrics.columns;
        if (Array.isArray(columns)) {
            return columns[idx];
        } else if (typeof Immutable !== 'undefined') {
            return columns.get(idx);
        }
    };

    this.getSize = function () {
        var columns = _this3.state.columnMetrics.columns;
        if (Array.isArray(columns)) {
            return columns.length;
        } else if (typeof Immutable !== 'undefined') {
            return columns.size;
        }
    };

    this.metricsUpdated = function () {
        var columnMetrics = _this3.createColumnMetrics();
        _this3.setState({ columnMetrics: columnMetrics });
    };

    this.createColumnMetrics = function () {
        var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this3.props;

        var gridColumns = _this3.setupGridColumns(props);
        return _this3.getColumnMetricsType({
            columns: gridColumns,
            minColumnWidth: _this3.props.minColumnWidth,
            totalWidth: props.minWidth
        });
    };

    this.onColumnResize = function (index, width, scrollleft, totalWidth) {
        var prevWidth = _this3.state.columnMetrics.columns[index].width;
        var columnMetrics = ColumnMetrics.resizeColumn(_this3.state.columnMetrics, index, width);
        var fullWidth = columnMetrics.width;
        var totalWidth2 = columnMetrics.totalWidth;
        /*for (let i = 0; i < this.state.columnMetrics.columns.length; i++) {
          fullWidth += this.state.columnMetrics.columns[i].width;
        }*/
        var needResizeLast = false;
        var lastColumnWidth = 0;
        if (fullWidth < columnMetrics.totalWidth) {
            needResizeLast = true;
            if (index != _this3.state.columnMetrics.columns.length - 1) {
                lastColumnWidth = _this3.state.columnMetrics.columns[_this3.state.columnMetrics.columns.length - 1].width + columnMetrics.totalWidth - fullWidth - 10;
                columnMetrics = ColumnMetrics.resizeColumn(_this3.state.columnMetrics, _this3.state.columnMetrics.columns.length - 1, lastColumnWidth);
            } else {
                columnMetrics = ColumnMetrics.resizeColumn(_this3.state.columnMetrics, index, width + prevWidth);
            }
        }
        /*if( scrollleft + fullWidth + prevWidth - width > totalWidth) {
            scrollleft = scrollleft - (prevWidth - width);
        }*/
        if (prevWidth > width && columnMetrics.totalWidth <= columnMetrics.width && scrollleft + columnMetrics.width > columnMetrics.totalWidth) {
            scrollleft = scrollleft - (prevWidth - width);
            // needResizeLast = true;
            // lastColumnWidth = this.state.columnMetrics.columns[this.state.columnMetrics.columns.length - 1].width + totalWidth - fullWidth;
            // columnMetrics = ColumnMetrics.resizeColumn(this.state.columnMetrics,
            //     this.state.columnMetrics.columns.length - 1, lastColumnWidth);
        }
        /*let needResizePrev = false;
        if(this.state.columnMetrics.columns.length - 1!=index){
            needResizeLast = true;
            lastColumnWidth = this.state.columnMetrics.columns[0].width +1;
            columnMetrics = ColumnMetrics.resizeColumn(this.state.columnMetrics,
                0, lastColumnWidth);
        }*/
        //this.props.columns[index].width = width;
        _this3.setState({ columnMetrics: columnMetrics });
        if (_this3.props.onColumnResize) {
            _this3.props.onColumnResize(index, width, scrollleft);
            if (needResizeLast === true) {
                _this3.props.onColumnResize(_this3.state.columnMetrics.columns.length - 1, lastColumnWidth, scrollleft);
            }
        }
    };

    this.onKeyDown = function (e) {
        if ((0, _keyboardUtils.isCtrlKeyHeldDown)(e)) {
            _this3.checkAndCall('onPressKeyWithCtrl', e);
        } else if (_this3.isKeyExplicitlyHandled(e.key)) {
            // break up individual keyPress events to have their own specific callbacks
            var callBack = 'onPress' + e.key;
            _this3.checkAndCall(callBack, e);
        } else if ((0, _keyboardUtils.isKeyPrintable)(e.keyCode)) {
            _this3.checkAndCall('onPressChar', e);
        }

        // Track which keys are currently down for shift clicking etc
        _this3._keysDown = _this3._keysDown || {};
        _this3._keysDown[e.keyCode] = true;
        if (isFunction(_this3.props.onGridKeyDown)) {
            _this3.props.onGridKeyDown(e);
        }
    };

    this.onKeyUp = function (e) {
        // Track which keys are currently down for shift clicking etc
        _this3._keysDown = _this3._keysDown || {};
        delete _this3._keysDown[e.keyCode];

        if (isFunction(_this3.props.onGridKeyUp)) {
            _this3.props.onGridKeyUp(e);
        }
    };

    this.isKeyDown = function (keyCode) {
        if (!_this3._keysDown) return false;
        return keyCode in _this3._keysDown;
    };

    this.isSingleKeyDown = function (keyCode) {
        if (!_this3._keysDown) return false;
        return keyCode in _this3._keysDown && Object.keys(_this3._keysDown).length === 1;
    };

    this.checkAndCall = function (methodName, args) {
        if (typeof _this3[methodName] === 'function') {
            _this3[methodName](args);
        }
    };

    this.isKeyExplicitlyHandled = function (key) {
        return typeof _this3['onPress' + key] === 'function';
    };

    this.hasSelectedCellChanged = function (selected) {
        var previouslySelected = Object.assign({}, _this3.state.selected);
        return previouslySelected.rowIdx !== selected.rowIdx || previouslySelected.idx !== selected.idx || previouslySelected.active === false;
    };

    this.onContextMenuHide = function () {
        document.removeEventListener('click', _this3.onContextMenuHide);
        var newSelected = Object.assign({}, _this3.state.selected, { contextMenuDisplayed: false });
        _this3.setState({ selected: newSelected });
    };

    this.onColumnEvent = function (ev, columnEvent) {
        var idx = columnEvent.idx,
            name = columnEvent.name;


        if (name && typeof idx !== 'undefined') {
            var column = _this3.getColumn(idx);

            if (column && column.events && column.events[name] && typeof column.events[name] === 'function') {
                var eventArgs = {
                    idx: idx,
                    rowIdx: columnEvent.rowIdx,
                    rowId: columnEvent.rowId,
                    column: column
                };

                column.events[name](ev, eventArgs);
            }
        }
    };

    this.onSelect = function (selected) {
        if (_this3.state.selected.rowIdx !== selected.rowIdx || _this3.state.selected.idx !== selected.idx || _this3.state.selected.active === false) {
            var _idx = selected.idx;
            var _rowIdx = selected.rowIdx;
            if (_this3.isCellWithinBounds(selected)) {
                var oldSelection = _this3.state.selected;
                _this3.setState({ selected: selected }, function () {
                    if (typeof _this3.props.onCellDeSelected === 'function') {
                        _this3.props.onCellDeSelected(oldSelection);
                    }
                    if (typeof _this3.props.onCellSelected === 'function') {
                        _this3.props.onCellSelected(selected);
                    }
                });
            } else if (_rowIdx === -1 && _idx === -1) {
                // When it's outside of the grid, set rowIdx anyway
                _this3.setState({ selected: { idx: _idx, rowIdx: _rowIdx } });
            }
        }
    };

    this.onCellClick = function (cell, e) {
        _this3.onSelect({ rowIdx: cell.rowIdx, idx: cell.idx });

        if (_this3.props.onRowClick && typeof _this3.props.onRowClick === 'function') {
            _this3.props.onRowClick(cell.rowIdx, _this3.props.rowGetter(cell.rowIdx), _this3.getColumn(cell.idx));
        }

        if (e) {
            e.stopPropagation();
        }
    };

    this.onCellFocus = function (cell) {
        _this3.onSelect(cell);
    };

    this.onCellContextMenu = function (cell) {
        _this3.onSelect({ rowIdx: cell.rowIdx, idx: cell.idx, contextMenuDisplayed: _this3.props.contextMenu });
        if (_this3.props.contextMenu) {
            document.addEventListener('click', _this3.onContextMenuHide);
        }
    };

    this.onCellDoubleClick = function (cell, e) {
        _this3.onSelect({ rowIdx: cell.rowIdx, idx: cell.idx });
        if (_this3.props.onRowDoubleClick && typeof _this3.props.onRowDoubleClick === 'function') {
            _this3.props.onRowDoubleClick(cell.rowIdx, _this3.props.rowGetter(cell.rowIdx), _this3.getColumn(cell.idx));
        }
        _this3.setActive();
        if (e) {
            e.stopPropagation();
        }
    };

    this.onPressArrowUp = function (e) {
        _this3.moveSelectedCell(e, -1, 0);
    };

    this.onPressArrowDown = function (e) {
        _this3.moveSelectedCell(e, 1, 0);
    };

    this.onPressArrowLeft = function (e) {
        _this3.moveSelectedCell(e, 0, -1);
    };

    this.onPressArrowRight = function (e) {
        _this3.moveSelectedCell(e, 0, 1);
    };

    this.isFocusedOnCell = function () {
        return document.activeElement && document.activeElement.classList && document.activeElement.classList.contains('react-grid-Cell');
    };

    this.isFocusedOnTable = function () {
        var domNode = _this3.getDataGridDOMNode();
        return domNode && domNode.contains(document.activeElement);
    };

    this.exitGrid = function (oldSelectedCell, newSelectedValue) {
        _this3.setState({ selected: newSelectedValue }, function () {
            if (typeof _this3.props.onCellDeSelected === 'function') {
                _this3.props.onCellDeSelected(oldSelectedCell);
            }
        });
    };

    this.enterGrid = function (newSelectedValue) {
        _this3.setState({ selected: newSelectedValue }, function () {
            if (typeof _this3.props.onCellSelected === 'function') {
                _this3.props.onCellSelected(newSelectedValue);
            }
        });
    };

    this.onPressTab = function (e) {
        // Scenario 0a: When there are no rows in the grid, pressing tab needs to allow the browser to handle it
        if (_this3.props.rowsCount === 0) {
            return;
        }
        // Scenario 0b: When we're editing a cell
        var idx = _this3.state.selected.idx;
        var rowIdx = _this3.state.selected.rowIdx;
        if (_this3.state.selected.active === true) {
            // if we are in a position to leave the grid, stop editing but stay in that cell
            if (_this3.canExitGrid(e)) {
                _this3.moveSelectedCell(e, 0, 0);
                return;
            }
            // otherwise move left or right as appropriate
            _this3.moveSelectedCell(e, 0, e.shiftKey ? -1 : 1);
            return;
        }
        var shift = e.shiftKey === true;
        // Scenario 1: we're at a cell where we can exit the grid
        if (_this3.canExitGrid(e) && _this3.isFocusedOnCell()) {
            if (shift && idx >= 0) {
                _this3.exitGrid({ idx: idx, rowIdx: rowIdx }, { idx: -1, rowIdx: rowIdx, exitedLeft: true });
                return;
            } else if (!shift && idx >= 0) {
                _this3.exitGrid({ idx: idx, rowIdx: rowIdx }, { idx: -1, rowIdx: rowIdx });
                return;
            }
        }
        // Scenario 2: we're on the div surrounding the grid and press shift+Tab
        // and we just exited left, so we want to let the browser handle it
        // KNOWN ISSUE: Focus on the table can come from either side and at this point we can't know how
        // they user arrived, so it is possible that exitLeft gets set and then the user clicks out of the table
        // and they won't be able to Shift+Tab around the site to re-enter the table from the right.
        if (_this3.isFocusedOnTable() && !_this3.isFocusedOnCell() && shift && _this3.state.selected.exitedLeft) {
            _this3.enterGrid({ idx: idx, rowIdx: rowIdx });
            return;
        }
        // Scenario 3: we're on the div surrounding the grid and we want to enter the grid
        if (!_this3.isFocusedOnCell()) {
            // Scenario 3A: idx has been set to -1 (eg can happen when clicking into the filter box)
            // we want to go to the first cell in the row if we press Tab
            // we want to go to the last cell in the row if we press Shift+Tab
            if (idx === -1) {
                _this3.moveSelectedCell(e, rowIdx === -1 ? 1 : 0, shift ? _this3.getNbrColumns() : 1);
                return;
            }
            // otherwise, there is a selected cell in the table already, and
            // we want to trigger it to focus - setting selected in state will update
            // the cell props, and checkFocus will be called
            _this3.enterGrid({ idx: idx, rowIdx: rowIdx, changeSomething: true });
            // make sure the browser doesn't handle it
            e.preventDefault();
            return;
        }
        _this3.moveSelectedCell(e, 0, e.shiftKey ? -1 : 1);
    };

    this.onPressEnter = function (e) {
        _this3.setActive(e.key);
    };

    this.onPressDelete = function (e) {
        _this3.setActive(e.key);
    };

    this.onPressEscape = function (e) {
        _this3.setInactive(e.key);
        _this3.handleCancelCopy();
    };

    this.onPressBackspace = function (e) {
        _this3.setActive(e.key);
    };

    this.onPressChar = function (e) {
        if ((0, _keyboardUtils.isKeyPrintable)(e.keyCode)) {
            _this3.setActive(e.keyCode);
        }
    };

    this.onPressKeyWithCtrl = function (e) {
        var keys = {
            KeyCode_c: 99,
            KeyCode_C: 67,
            KeyCode_V: 86,
            KeyCode_v: 118
        };

        var rowIdx = _this3.state.selected.rowIdx;
        var row = _this3.props.rowGetter(rowIdx);

        var idx = _this3.state.selected.idx;
        var col = _this3.getColumn(idx);

        if (ColumnUtils.canEdit(col, row, _this3.props.enableCellSelect)) {
            if (e.keyCode === keys.KeyCode_c || e.keyCode === keys.KeyCode_C) {
                var _value = _this3.getSelectedValue();
                _this3.handleCopy({ value: _value });
            } else if (e.keyCode === keys.KeyCode_v || e.keyCode === keys.KeyCode_V) {
                _this3.handlePaste();
            }
        }
    };

    this.onGridRowsUpdated = function (cellKey, fromRow, toRow, updated, action, originRow) {
        var rowIds = [];

        for (var i = fromRow; i <= toRow; i++) {
            rowIds.push(_this3.props.rowGetter(i)[_this3.props.rowKey]);
        }

        var fromRowData = _this3.props.rowGetter(action === 'COPY_PASTE' ? originRow : fromRow);
        var fromRowId = fromRowData[_this3.props.rowKey];
        var toRowId = _this3.props.rowGetter(toRow)[_this3.props.rowKey];
        _this3.props.onGridRowsUpdated({
            cellKey: cellKey,
            fromRow: fromRow,
            toRow: toRow,
            fromRowId: fromRowId,
            toRowId: toRowId,
            rowIds: rowIds,
            updated: updated,
            action: action,
            fromRowData: fromRowData
        });
    };

    this.onCellCommit = function (commit) {
        var selected = Object.assign({}, _this3.state.selected);
        selected.active = false;
        var expandedRows = _this3.state.expandedRows;
        // if(commit.changed && commit.changed.expandedHeight){
        //   expandedRows = this.expandRow(commit.rowIdx, commit.changed.expandedHeight);
        // }
        _this3.setState({ selected: selected, expandedRows: expandedRows });

        if (_this3.props.onRowUpdated) {
            _this3.props.onRowUpdated(commit);
        }

        var targetRow = commit.rowIdx;

        if (_this3.props.onGridRowsUpdated) {
            _this3.onGridRowsUpdated(commit.cellKey, targetRow, targetRow, commit.updated, _AppConstants2['default'].UpdateActions.CELL_UPDATE);
        }
    };

    this.onDragStart = function (e) {
        var idx = _this3.state.selected.idx;
        // To prevent dragging down/up when reordering rows.
        var isViewportDragging = e && e.target && e.target.className;
        if (idx > -1 && isViewportDragging) {
            var _value2 = _this3.getSelectedValue();
            _this3.handleDragStart({ idx: _this3.state.selected.idx, rowIdx: _this3.state.selected.rowIdx, value: _value2 });
            // need to set dummy data for FF
            if (e && e.dataTransfer) {
                if (e.dataTransfer.setData) {
                    e.dataTransfer.dropEffect = 'move';
                    e.dataTransfer.effectAllowed = 'move';
                    e.dataTransfer.setData('text/plain', '');
                }
            }
        }
    };

    this.onToggleFilter = function () {
        // setState() does not immediately mutate this.state but creates a pending state transition.
        // Therefore if you want to do something after the state change occurs, pass it in as a callback function.
        _this3.setState({ canFilter: !_this3.state.canFilter }, function () {
            if (_this3.state.canFilter === false && _this3.props.onClearFilters) {
                _this3.props.onClearFilters();
            }
        });
    };

    this.onDragHandleDoubleClick = function (e) {
        if (_this3.props.onDragHandleDoubleClick) {
            _this3.props.onDragHandleDoubleClick(e);
        }

        if (_this3.props.onGridRowsUpdated) {
            var cellKey = _this3.getColumn(e.idx).key;
            _this3.onGridRowsUpdated(cellKey, e.rowIdx, _this3.props.rowsCount - 1, _defineProperty({}, cellKey, e.rowData[cellKey]), _AppConstants2['default'].UpdateActions.COLUMN_FILL);
        }
    };

    this.onCellExpand = function (args) {
        if (_this3.props.onCellExpand) {
            _this3.props.onCellExpand(args);
        }
    };

    this.onRowExpandToggle = function (args) {
        if (typeof _this3.props.onRowExpandToggle === 'function') {
            _this3.props.onRowExpandToggle(args);
        }
    };

    this.isCellWithinBounds = function (_ref) {
        var idx = _ref.idx,
            rowIdx = _ref.rowIdx;

        return idx >= 0 && rowIdx >= 0 && idx < ColumnUtils.getSize(_this3.state.columnMetrics.columns) && rowIdx < _this3.props.rowsCount;
    };

    this.handleDragStart = function (dragged) {
        if (!_this3.dragEnabled()) {
            return;
        }
        if (_this3.isCellWithinBounds(dragged)) {
            _this3.setState({ dragged: dragged });
        }
    };

    this.handleDragEnd = function () {
        if (!_this3.dragEnabled()) {
            return;
        }
        var _state = _this3.state,
            selected = _state.selected,
            dragged = _state.dragged;

        var column = _this3.getColumn(_this3.state.selected.idx);
        if (selected && dragged && column) {
            var cellKey = column.key;
            var fromRow = selected.rowIdx < dragged.overRowIdx ? selected.rowIdx : dragged.overRowIdx;
            var toRow = selected.rowIdx > dragged.overRowIdx ? selected.rowIdx : dragged.overRowIdx;
            if (_this3.props.onCellsDragged) {
                _this3.props.onCellsDragged({ cellKey: cellKey, fromRow: fromRow, toRow: toRow, value: dragged.value });
            }
            if (_this3.props.onGridRowsUpdated) {
                _this3.onGridRowsUpdated(cellKey, fromRow, toRow, _defineProperty({}, cellKey, dragged.value), _AppConstants2['default'].UpdateActions.CELL_DRAG);
            }
        }
        _this3.setState({ dragged: { complete: true } });
    };

    this.handleDragEnter = function (row) {
        if (!_this3.dragEnabled() || _this3.state.dragged == null) {
            return;
        }
        var dragged = _this3.state.dragged;
        dragged.overRowIdx = row;
        _this3.setState({ dragged: dragged });
    };

    this.handleTerminateDrag = function () {
        if (!_this3.dragEnabled()) {
            return;
        }
        _this3.setState({ dragged: null });
    };

    this.handlePaste = function () {
        if (!_this3.copyPasteEnabled() || !_this3.state.copied) {
            return;
        }
        var selected = _this3.state.selected;
        var cellKey = _this3.getColumn(_this3.state.selected.idx).key;
        var textToCopy = _this3.state.textToCopy;
        var fromRow = _this3.state.copied.rowIdx;
        var toRow = selected.rowIdx;

        if (_this3.props.onCellCopyPaste) {
            _this3.props.onCellCopyPaste({
                cellKey: cellKey,
                rowIdx: toRow,
                value: textToCopy,
                fromRow: fromRow,
                toRow: toRow
            });
        }

        if (_this3.props.onGridRowsUpdated) {
            _this3.onGridRowsUpdated(cellKey, toRow, toRow, _defineProperty({}, cellKey, textToCopy), _AppConstants2['default'].UpdateActions.COPY_PASTE, fromRow);
        }
    };

    this.handleCancelCopy = function () {
        _this3.setState({ copied: null });
    };

    this.handleCopy = function (args) {
        if (!_this3.copyPasteEnabled()) {
            return;
        }
        var textToCopy = args.value;
        var selected = _this3.state.selected;
        var copied = { idx: selected.idx, rowIdx: selected.rowIdx };
        _this3.setState({ textToCopy: textToCopy, copied: copied });
    };

    this.handleSort = function (columnKey, direction) {
        var stateChange = {
            sortDirection: direction,
            sortColumn: columnKey
        };
        var isMultiple = _this3.props.multipleColumnsSort;
        if (isMultiple) {
            var sort = _this3.state.sort.slice();
            if (direction === SortableHeaderCell.DEFINE_SORT.NONE) {
                sort = sort.filter(function (item) {
                    return item.column !== columnKey;
                });
            } else {
                var sortData = { column: columnKey, direction: direction };
                var columnIndex = sort.map(function (s, index) {
                    if (s.column === columnKey) return index;
                }).filter(isFinite)[0];
                if (typeof columnIndex === 'number') {
                    // Overwrite the object, because shallowEqual is used for sort array comparison in shouldComponentUpdate
                    sort[columnIndex] = sortData;
                } else {
                    sort.push(sortData);
                }
            }
            stateChange.sort = sort;
        }

        _this3.setState(stateChange, function () {
            isMultiple ? _this3.props.onGridMultipleColumnsSort(stateChange.sort, columnKey, direction) : _this3.props.onGridSort(columnKey, direction);
        });
    };

    this.getSelectedRow = function (rows, key) {
        var selectedRow = rows.filter(function (r) {
            if (r[_this3.props.rowKey] === key) {
                return true;
            }
            return false;
        });
        if (selectedRow.length > 0) {
            return selectedRow[0];
        }
    };

    this.useNewRowSelection = function () {
        return _this3.props.rowSelection && _this3.props.rowSelection.selectBy;
    };

    this.handleShiftSelect = function (rowIdx) {
        if (_this3.state.lastRowIdxUiSelected > -1 && _this3.isSingleKeyDown(KeyCodes.Shift)) {
            var _props$rowSelection$s = _this3.props.rowSelection.selectBy,
                keys = _props$rowSelection$s.keys,
                indexes = _props$rowSelection$s.indexes,
                isSelectedKey = _props$rowSelection$s.isSelectedKey;

            var isPreviouslySelected = RowUtils.isRowSelected(keys, indexes, isSelectedKey, _this3.props.rowGetter(rowIdx), rowIdx);

            if (isPreviouslySelected) return false;

            var handled = false;

            if (rowIdx > _this3.state.lastRowIdxUiSelected) {
                var rowsSelected = [];

                for (var i = _this3.state.lastRowIdxUiSelected + 1; i <= rowIdx; i++) {
                    rowsSelected.push({ rowIdx: i, row: _this3.props.rowGetter(i) });
                }

                if (typeof _this3.props.rowSelection.onRowsSelected === 'function') {
                    _this3.props.rowSelection.onRowsSelected(rowsSelected);
                }

                handled = true;
            } else if (rowIdx < _this3.state.lastRowIdxUiSelected) {
                var _rowsSelected = [];

                for (var _i = rowIdx; _i <= _this3.state.lastRowIdxUiSelected - 1; _i++) {
                    _rowsSelected.push({ rowIdx: _i, row: _this3.props.rowGetter(_i) });
                }

                if (typeof _this3.props.rowSelection.onRowsSelected === 'function') {
                    _this3.props.rowSelection.onRowsSelected(_rowsSelected);
                }

                handled = true;
            }

            if (handled) {
                _this3.setState({ lastRowIdxUiSelected: rowIdx });
            }

            return handled;
        }

        return false;
    };

    this.handleNewRowSelect = function (rowIdx, rowData) {
        if (_this3.selectAllCheckbox && _this3.selectAllCheckbox.checked === true) {
            _this3.selectAllCheckbox.checked = false;
        }

        var _props$rowSelection$s2 = _this3.props.rowSelection.selectBy,
            keys = _props$rowSelection$s2.keys,
            indexes = _props$rowSelection$s2.indexes,
            isSelectedKey = _props$rowSelection$s2.isSelectedKey;

        var isPreviouslySelected = RowUtils.isRowSelected(keys, indexes, isSelectedKey, rowData, rowIdx);

        _this3.setState({ lastRowIdxUiSelected: isPreviouslySelected ? -1 : rowIdx, selected: { rowIdx: rowIdx, idx: 0 } });

        if (isPreviouslySelected && typeof _this3.props.rowSelection.onRowsDeselected === 'function') {
            _this3.props.rowSelection.onRowsDeselected([{ rowIdx: rowIdx, row: rowData }]);
        } else if (!isPreviouslySelected && typeof _this3.props.rowSelection.onRowsSelected === 'function') {
            _this3.props.rowSelection.onRowsSelected([{ rowIdx: rowIdx, row: rowData }]);
        }
    };

    this.handleRowSelect = function (rowIdx, columnKey, rowData, e) {
        e.stopPropagation();

        if (_this3.useNewRowSelection()) {
            if (_this3.props.rowSelection.enableShiftSelect === true) {
                if (!_this3.handleShiftSelect(rowIdx)) {
                    _this3.handleNewRowSelect(rowIdx, rowData);
                }
            } else {
                _this3.handleNewRowSelect(rowIdx, rowData);
            }
        } else {
            // Fallback to old onRowSelect handler
            var selectedRows = _this3.props.enableRowSelect === 'single' ? [] : _this3.state.selectedRows.slice(0);
            var selectedRow = _this3.getSelectedRow(selectedRows, rowData[_this3.props.rowKey]);
            if (selectedRow) {
                selectedRow.isSelected = !selectedRow.isSelected;
            } else {
                rowData.isSelected = true;
                selectedRows.push(rowData);
            }
            _this3.setState({ selectedRows: selectedRows, selected: { rowIdx: rowIdx, idx: 0 } });
            if (_this3.props.onRowSelect) {
                _this3.props.onRowSelect(selectedRows.filter(function (r) {
                    return r.isSelected === true;
                }));
            }
        }
    };

    this.handleCheckboxChange = function (e) {
        var allRowsSelected = void 0;
        if (e.currentTarget instanceof HTMLInputElement && e.currentTarget.checked === true) {
            allRowsSelected = true;
        } else {
            allRowsSelected = false;
        }
        if (_this3.useNewRowSelection()) {
            var _props$rowSelection$s3 = _this3.props.rowSelection.selectBy,
                keys = _props$rowSelection$s3.keys,
                indexes = _props$rowSelection$s3.indexes,
                isSelectedKey = _props$rowSelection$s3.isSelectedKey;


            if (allRowsSelected && typeof _this3.props.rowSelection.onRowsSelected === 'function') {
                var selectedRows = [];
                for (var i = 0; i < _this3.props.rowsCount; i++) {
                    var rowData = _this3.props.rowGetter(i);
                    if (!RowUtils.isRowSelected(keys, indexes, isSelectedKey, rowData, i)) {
                        selectedRows.push({ rowIdx: i, row: rowData });
                    }
                }

                if (selectedRows.length > 0) {
                    _this3.props.rowSelection.onRowsSelected(selectedRows);
                }
            } else if (!allRowsSelected && typeof _this3.props.rowSelection.onRowsDeselected === 'function') {
                var deselectedRows = [];
                for (var _i2 = 0; _i2 < _this3.props.rowsCount; _i2++) {
                    var _rowData = _this3.props.rowGetter(_i2);
                    if (RowUtils.isRowSelected(keys, indexes, isSelectedKey, _rowData, _i2)) {
                        deselectedRows.push({ rowIdx: _i2, row: _rowData });
                    }
                }

                if (deselectedRows.length > 0) {
                    _this3.props.rowSelection.onRowsDeselected(deselectedRows);
                }
            }
        } else {
            var _selectedRows = [];
            for (var _i3 = 0; _i3 < _this3.props.rowsCount; _i3++) {
                var row = Object.assign({}, _this3.props.rowGetter(_i3), { isSelected: allRowsSelected });
                _selectedRows.push(row);
            }
            _this3.setState({ selectedRows: _selectedRows });
            if (typeof _this3.props.onRowSelect === 'function') {
                _this3.props.onRowSelect(_selectedRows.filter(function (r) {
                    return r.isSelected === true;
                }));
            }
        }
    };

    this.getScrollOffSet = function () {
        var scrollOffset = 0;
        if (_this3.grid) {
            var canvas = _this3.grid.querySelector('.react-grid-Canvas');
            if (canvas) {
                scrollOffset = canvas.offsetWidth - canvas.clientWidth;
            }
        }
        _this3.setState({ scrollOffset: scrollOffset });
    };

    this.getRowOffsetHeight = function () {
        var offsetHeight = 0;
        _this3.getHeaderRows().forEach(function (row) {
            return offsetHeight += parseFloat(row.height, 10);
        });
        return offsetHeight;
    };

    this.getHeaderRows = function () {
        var rows = [{
            ref: function ref(node) {
                return _this3.row = node;
            },
            height: _this3.props.headerRowHeight || _this3.props.rowHeight,
            rowType: 'header'
        }];
        if (_this3.state.canFilter === true) {
            rows.push({
                ref: function ref(node) {
                    return _this3.filterRow = node;
                },
                filterable: true,
                //onFilterChange: this.props.onAddFilter,
                height: _this3.props.headerFiltersHeight,
                rowType: 'filter'
            });
        }
        return rows;
    };

    this.getInitialSelectedRows = function () {
        var selectedRows = [];
        for (var i = 0; i < _this3.props.rowsCount; i++) {
            selectedRows.push(false);
        }
        return selectedRows;
    };

    this.getRowSelectionProps = function () {
        if (_this3.props.rowSelection) {
            return _this3.props.rowSelection.selectBy;
        }

        return null;
    };

    this.getSelectedRows = function () {
        if (_this3.props.rowSelection) {
            return null;
        }

        return _this3.state.selectedRows.filter(function (r) {
            return r.isSelected === true;
        });
    };

    this.getSelectedValue = function () {
        var rowIdx = _this3.state.selected.rowIdx;
        var idx = _this3.state.selected.idx;
        var cellKey = _this3.getColumn(idx).key;
        var row = _this3.props.rowGetter(rowIdx);
        return RowUtils.get(row, cellKey);
    };

    this.canExitGrid = function (e) {
        // When the cellNavigationMode is 'none', you can exit the grid if you're at the start or end of the row
        // When the cellNavigationMode is 'changeRow', you can exit the grid if you're at the first or last cell of the grid
        // When the cellNavigationMode is 'loopOverRow', there is no logical exit point so you can't exit the grid
        var atLastCellInRow = _this3.isAtLastCellInRow(_this3.getNbrColumns());
        var atFirstCellInRow = _this3.isAtFirstCellInRow();
        var atLastRow = _this3.isAtLastRow();
        var atFirstRow = _this3.isAtFirstRow();
        var shift = e.shiftKey === true;
        var cellNavigationMode = _this3.props.cellNavigationMode;

        if (shift) {
            if (cellNavigationMode === 'none') {
                if (atFirstCellInRow) {
                    return true;
                }
            } else if (cellNavigationMode === 'changeRow') {
                if (atFirstCellInRow && atFirstRow) {
                    return true;
                }
            }
        } else {
            if (cellNavigationMode === 'none') {
                if (atLastCellInRow) {
                    return true;
                }
            } else if (cellNavigationMode === 'changeRow') {
                if (atLastCellInRow && atLastRow) {
                    return true;
                }
            }
        }
        return false;
    };

    this.moveSelectedCell = function (e, rowDelta, cellDelta) {
        // we need to prevent default as we control grid scroll
        // otherwise it moves every time you left/right which is janky
        e.preventDefault();
        var rowIdx = void 0;
        var idx = void 0;
        var cellNavigationMode = _this3.props.cellNavigationMode;

        if (cellNavigationMode !== 'none') {
            var _calculateNextSelecti = _this3.calculateNextSelectionPosition(cellNavigationMode, cellDelta, rowDelta);

            idx = _calculateNextSelecti.idx;
            rowIdx = _calculateNextSelecti.rowIdx;
        } else {
            rowIdx = _this3.state.selected.rowIdx + rowDelta;
            idx = _this3.state.selected.idx + cellDelta;
        }
        _this3.scrollToColumn(idx);
        _this3.onSelect({ idx: idx, rowIdx: rowIdx });
    };

    this.getNbrColumns = function () {
        var _props = _this3.props,
            columns = _props.columns,
            enableRowSelect = _props.enableRowSelect;

        return enableRowSelect ? columns.length + 1 : columns.length;
    };

    this.getDataGridDOMNode = function () {
        return _this3.grid;
    };

    this.calculateNextSelectionPosition = function (cellNavigationMode, cellDelta, rowDelta) {
        var _rowDelta = rowDelta;
        var idx = _this3.state.selected.idx + cellDelta;
        var nbrColumns = _this3.getNbrColumns();
        if (cellDelta > 0) {
            if (_this3.isAtLastCellInRow(nbrColumns)) {
                if (cellNavigationMode === 'changeRow') {
                    _rowDelta = _this3.isAtLastRow() ? rowDelta : rowDelta + 1;
                    idx = _this3.isAtLastRow() ? idx : 0;
                } else {
                    idx = 0;
                }
            }
        } else if (cellDelta < 0) {
            if (_this3.isAtFirstCellInRow()) {
                if (cellNavigationMode === 'changeRow') {
                    _rowDelta = _this3.isAtFirstRow() ? rowDelta : rowDelta - 1;
                    idx = _this3.isAtFirstRow() ? 0 : nbrColumns - 1;
                } else {
                    idx = nbrColumns - 1;
                }
            }
        }
        var rowIdx = _this3.state.selected.rowIdx + _rowDelta;
        return { idx: idx, rowIdx: rowIdx };
    };

    this.isAtLastCellInRow = function (nbrColumns) {
        return _this3.state.selected.idx === nbrColumns - 1;
    };

    this.isAtLastRow = function () {
        return _this3.state.selected.rowIdx === _this3.props.rowsCount - 1;
    };

    this.isAtFirstCellInRow = function () {
        return _this3.state.selected.idx === 0;
    };

    this.isAtFirstRow = function () {
        return _this3.state.selected.rowIdx === 0;
    };

    this.openCellEditor = function (rowIdx, idx) {
        var row = _this3.props.rowGetter(rowIdx);
        var col = _this3.getColumn(idx);

        if (!ColumnUtils.canEdit(col, row, _this3.props.enableCellSelect)) {
            return;
        }

        var selected = { rowIdx: rowIdx, idx: idx };
        if (_this3.hasSelectedCellChanged(selected)) {
            _this3.setState({ selected: selected }, function () {
                _this3.setActive('Enter');
            });
        } else {
            _this3.setActive('Enter');
        }
    };

    this.scrollToColumn = function (colIdx) {
        if (_this3.grid) {
            var canvas = _this3.grid.querySelector('.react-grid-Canvas');
            if (canvas) {
                var left = 0;
                var locked = 0;

                for (var i = 0; i < colIdx; i++) {
                    var column = _this3.getColumn(i);
                    if (column) {
                        if (column.width) {
                            left += column.width;
                        }
                        if (column.locked) {
                            locked += column.width;
                        }
                    }
                }

                var selectedColumn = _this3.getColumn(colIdx);
                if (selectedColumn) {
                    var scrollLeft = left - locked - canvas.scrollLeft;
                    var scrollRight = left + selectedColumn.width - canvas.scrollLeft;

                    if (scrollLeft < 0) {
                        canvas.scrollLeft += scrollLeft;
                    } else if (scrollRight > canvas.clientWidth) {
                        var scrollAmount = scrollRight - canvas.clientWidth;
                        canvas.scrollLeft += scrollAmount;
                    }
                }
            }
        }
    };

    this.setScrollLeft = function (left) {
        _this3.base.onScroll({ scrollLeft: left });
    };

    this.deselect = function () {
        var selected = { rowIdx: -1, idx: -1 };
        _this3.setState({ selected: selected });
    };

    this.setActive = function (keyPressed) {
        var rowIdx = _this3.state.selected.rowIdx;
        var row = _this3.props.rowGetter(rowIdx);

        var idx = _this3.state.selected.idx;
        var column = _this3.getColumn(idx);

        if (ColumnUtils.canEdit(column, row, _this3.props.enableCellSelect) && !_this3.isActive()) {
            var selected = Object.assign({}, _this3.state.selected, {
                idx: idx,
                rowIdx: rowIdx,
                active: true,
                initialKeyCode: keyPressed
            });
            var showEditor = true;
            if (typeof _this3.props.onCheckCellIsEditable === 'function') {
                var args = Object.assign({}, { row: row, column: column }, selected);
                showEditor = _this3.props.onCheckCellIsEditable(args);
            }
            if (showEditor !== false) {
                if (column.locked) {
                    _this3.setState({ selected: selected });
                } else {
                    _this3.setState({ selected: selected }, function () {
                        _this3.scrollToColumn(idx);
                    });
                }
                _this3.props.onBeforeEdit();
                _this3.handleCancelCopy();
            }
        }
    };

    this.setInactive = function () {
        var rowIdx = _this3.state.selected.rowIdx;
        var row = _this3.props.rowGetter(rowIdx);

        var idx = _this3.state.selected.idx;
        var col = _this3.getColumn(idx);

        if (ColumnUtils.canEdit(col, row, _this3.props.enableCellSelect) && _this3.isActive()) {
            var selected = Object.assign({}, _this3.state.selected, { idx: idx, rowIdx: rowIdx, active: false });
            _this3.setState({ selected: selected });
        }
    };

    this.isActive = function () {
        return _this3.state.selected.active === true;
    };

    this.setupGridColumns = function () {
        var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this3.props;
        var columns = props.columns;

        if (_this3._cachedColumns === columns) {
            return _this3._cachedComputedColumns;
        }

        _this3._cachedColumns = columns;

        var cols = columns.slice(0);
        var unshiftedCols = {};
        if (_this3.props.rowActionsCell || props.enableRowSelect && !_this3.props.rowSelection || props.rowSelection && props.rowSelection.showCheckbox !== false) {
            var SelectAllComponent = _this3.props.selectAllRenderer || _SelectAll2['default'];
            var SelectAllRenderer = React.createElement(SelectAllComponent, { onChange: _this3.handleCheckboxChange,
                inputRef: function inputRef(grid) {
                    return _this3.selectAllCheckbox = grid;
                } });
            var headerRenderer = null; //this.props.enableRowSelect === 'single' ? null : SelectAllRenderer;//todo: нужна ли эта кнопка, если нужна надо настроить
            var Formatter = _this3.props.rowActionsCell ? _this3.props.rowActionsCell : CheckboxEditor;
            var selectColumn = {
                key: 'select-row',
                name: '',
                formatter: React.createElement(Formatter, { rowSelection: _this3.props.rowSelection }),
                onCellChange: _this3.handleRowSelect,
                filterable: false,
                headerRenderer: headerRenderer,
                width: 60,
                locked: true,
                getRowMetaData: function getRowMetaData(rowData) {
                    return rowData;
                },
                cellClass: _this3.props.rowActionsCell ? 'rdg-row-actions-cell' : ''
            };
            unshiftedCols = cols.unshift(selectColumn);
            cols = unshiftedCols > 0 ? cols : unshiftedCols;
        }
        _this3._cachedComputedColumns = cols;

        return _this3._cachedComputedColumns;
    };

    this.copyPasteEnabled = function () {
        return _this3.props.onCellCopyPaste !== null;
    };

    this.dragEnabled = function () {
        return _this3.props.onGridRowsUpdated !== undefined || _this3.props.onCellsDragged !== undefined;
    };

    this.renderToolbar = function () {
        var Toolbar = _this3.props.toolbar;
        var toolBarProps = {
            columns: _this3.props.columns,
            onToggleFilter: _this3.onToggleFilter,
            numberOfRows: _this3.props.rowsCount
        };
        if (React.isValidElement(Toolbar)) {
            return React.cloneElement(Toolbar, toolBarProps);
        } else if (isFunction(Toolbar)) {
            return React.createElement(Toolbar, toolBarProps);
        }
    };

    this.setAppliedFilters = function (filters) {
        _this3.base.setAppliedFilters(filters);
    };

    this.scrollToTop = function () {
        _this3.base.scrollToTop();
    };
}, _temp);
ReactDataGrid.propTypes = process.env.NODE_ENV !== "production" ? {
    rowHeight: _propTypes2['default'].number.isRequired,
    headerRowHeight: _propTypes2['default'].number,
    headerFiltersHeight: _propTypes2['default'].number,
    minHeight: _propTypes2['default'].number.isRequired,
    minWidth: _propTypes2['default'].number,
    enableRowSelect: _propTypes2['default'].oneOfType([_propTypes2['default'].bool, _propTypes2['default'].string]),
    onRowUpdated: _propTypes2['default'].func,
    rowGetter: _propTypes2['default'].func.isRequired,
    rowsCount: _propTypes2['default'].number.isRequired,
    toolbar: _propTypes2['default'].element,
    enableCellSelect: _propTypes2['default'].bool,
    columns: _propTypes2['default'].oneOfType([_propTypes2['default'].object, _propTypes2['default'].array]).isRequired,
    onFilter: _propTypes2['default'].func,
    onCellCopyPaste: _propTypes2['default'].func,
    onCellsDragged: _propTypes2['default'].func,
    getCellActions: _propTypes2['default'].func,
    onAddFilter: _propTypes2['default'].func,
    sort: SortDataShape,
    multipleColumnsSort: _propTypes2['default'].bool,
    onGridSort: _propTypes2['default'].func,
    onGridMultipleColumnsSort: _propTypes2['default'].func,
    sortColumn: _propTypes2['default'].string,
    sortDirection: _propTypes2['default'].oneOf(Object.keys(_SortableHeaderCell.DEFINE_SORT)),
    onDragHandleDoubleClick: _propTypes2['default'].func,
    onGridRowsUpdated: _propTypes2['default'].func,
    onRowSelect: _propTypes2['default'].func,
    rowKey: _propTypes2['default'].string,
    rowScrollTimeout: _propTypes2['default'].number,
    scrollToRowIndex: _propTypes2['default'].number,
    onClearFilters: _propTypes2['default'].func,
    contextMenu: _propTypes2['default'].element,
    cellNavigationMode: _propTypes2['default'].oneOf(['none', 'loopOverRow', 'changeRow']),
    onCellSelected: _propTypes2['default'].func,
    onCellDeSelected: _propTypes2['default'].func,
    onCellExpand: _propTypes2['default'].func,
    enableDragAndDrop: _propTypes2['default'].bool,
    tabIndex: _propTypes2['default'].number,
    onRowExpandToggle: _propTypes2['default'].func,
    draggableHeaderCell: _propTypes2['default'].func,
    getValidFilterValues: _propTypes2['default'].func,
    rowSelection: _propTypes2['default'].shape({
        enableShiftSelect: _propTypes2['default'].bool,
        onRowsSelected: _propTypes2['default'].func,
        onRowsDeselected: _propTypes2['default'].func,
        showCheckbox: _propTypes2['default'].bool,
        selectBy: _propTypes2['default'].oneOfType([_propTypes2['default'].shape({
            indexes: _propTypes2['default'].arrayOf(_propTypes2['default'].number).isRequired
        }), _propTypes2['default'].shape({
            isSelectedKey: _propTypes2['default'].string.isRequired
        }), _propTypes2['default'].shape({
            keys: _propTypes2['default'].shape({
                values: _propTypes2['default'].array.isRequired,
                rowKey: _propTypes2['default'].string.isRequired
            }).isRequired
        })]).isRequired
    }),
    onRowClick: _propTypes2['default'].func,
    onRowDoubleClick: _propTypes2['default'].func,
    onGridKeyUp: _propTypes2['default'].func,
    onGridKeyDown: _propTypes2['default'].func,
    rowGroupRenderer: _propTypes2['default'].func,
    rowActionsCell: _propTypes2['default'].func,
    onCheckCellIsEditable: _propTypes2['default'].func,
    /* called before cell is set active, returns a boolean to determine whether cell is editable */
    overScan: _propTypes2['default'].object,
    onDeleteSubRow: _propTypes2['default'].func,
    onAddSubRow: _propTypes2['default'].func,
    enableCellAutoFocus: _propTypes2['default'].bool,
    onBeforeEdit: _propTypes2['default'].func,
    selectAllRenderer: _propTypes2['default'].object,
    minColumnWidth: _propTypes2['default'].number,
    columnEquality: _propTypes2['default'].func,
    onColumnResize: _propTypes2['default'].func
    //onFilterChange: PropTypes.func.isRequired
} : {};


module.exports = ReactDataGrid;