'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _OverflowCell = require('./OverflowCell');

var _OverflowCell2 = _interopRequireDefault(_OverflowCell);

var _RowComparer = require('./RowComparer');

var _RowComparer2 = _interopRequireDefault(_RowComparer);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');

var joinClasses = require('classnames');
var Cell = require('./Cell');
var columnUtils = require('./ColumnUtils');
var cellMetaDataShape = require('./PropTypeShapes/CellMetaDataShape');
var createObjectWithProperties = require('./createObjectWithProperties');
require('./themes/react-data-grid-row.css');

var CellExpander = function (_React$Component) {
  _inherits(CellExpander, _React$Component);

  function CellExpander() {
    _classCallCheck(this, CellExpander);

    return _possibleConstructorReturn(this, (CellExpander.__proto__ || Object.getPrototypeOf(CellExpander)).apply(this, arguments));
  }

  _createClass(CellExpander, [{
    key: 'render',
    value: function render() {
      return React.createElement(Cell, this.props);
    }
  }]);

  return CellExpander;
}(React.Component);

// The list of the propTypes that we want to include in the Row div


var knownDivPropertyKeys = ['height'];

var Row = (_temp2 = _class = function (_React$Component2) {
  _inherits(Row, _React$Component2);

  function Row() {
    var _ref;

    var _temp, _this2, _ret;

    _classCallCheck(this, Row);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this2 = _possibleConstructorReturn(this, (_ref = Row.__proto__ || Object.getPrototypeOf(Row)).call.apply(_ref, [this].concat(args))), _this2), _this2.handleDragEnter = function () {
      var handleDragEnterRow = _this2.props.cellMetaData.handleDragEnterRow;
      if (handleDragEnterRow) {
        handleDragEnterRow(_this2.props.idx);
      }
    }, _this2.getSelectedColumn = function () {
      if (_this2.props.cellMetaData) {
        var selected = _this2.props.cellMetaData.selected;
        if (selected && selected.idx) {
          return columnUtils.getColumn(_this2.props.columns, selected.idx);
        }
      }
    }, _this2.getCellRenderer = function (columnKey) {
      var CellRenderer = _this2.props.cellRenderer;
      if (_this2.props.subRowDetails && _this2.props.subRowDetails.field === columnKey) {
        return CellExpander;
      }
      return CellRenderer;
    }, _this2.getCell = function (column, i, selectedColumn) {
      var CellRenderer = _this2.props.cellRenderer;
      var _this2$props = _this2.props,
          colVisibleStart = _this2$props.colVisibleStart,
          colVisibleEnd = _this2$props.colVisibleEnd,
          idx = _this2$props.idx,
          cellMetaData = _this2$props.cellMetaData;
      var key = column.key,
          formatter = column.formatter,
          locked = column.locked;

      var baseCellProps = { key: key + '-' + idx, idx: i, rowIdx: idx, height: _this2.getRowHeight(), column: column, cellMetaData: cellMetaData };

      /*if ((i < colVisibleStart || i > colVisibleEnd) && !locked) {
        return <OverflowCell ref={(node) => this[key] = node} {...baseCellProps} />;
      }*/

      var _this2$props2 = _this2.props,
          row = _this2$props2.row,
          isSelected = _this2$props2.isSelected;

      var cellProps = {
        ref: function ref(node) {
          return _this2[key] = node;
        },
        value: _this2.getCellValue(key || i),
        rowData: row,
        isRowSelected: isSelected,
        expandableOptions: _this2.getExpandableOptions(key),
        selectedColumn: selectedColumn,
        formatter: formatter,
        isScrolling: _this2.props.isScrolling
      };

      return React.createElement(CellRenderer, _extends({}, baseCellProps, cellProps));
    }, _this2.getCells = function () {
      var cells = [];
      var lockedCells = [];
      var selectedColumn = _this2.getSelectedColumn();
      var lastColumnIdx = _this2.props.columns.size - 1;
      if (_this2.props.columns) {
        _this2.props.columns.forEach(function (column, i) {
          if (i === lastColumnIdx) {
            column.isLastColumn = true;
          }
          var cell = _this2.getCell(column, i, selectedColumn);
          if (column.locked) {
            lockedCells.push(cell);
          } else {
            cells.push(cell);
          }
        });
      }

      return cells.concat(lockedCells);
    }, _this2.getRowHeight = function () {
      var rows = _this2.props.expandedRows || null;
      if (rows && _this2.props.idx) {
        var row = rows[_this2.props.idx] || null;
        if (row) {
          return row.height;
        }
      }
      return _this2.props.height;
    }, _this2.getCellValue = function (key) {
      var val = void 0;
      if (key === 'select-row') {
        return _this2.props.isSelected;
      } else if (typeof _this2.props.row.get === 'function') {
        val = _this2.props.row.get(key);
      } else {
        val = _this2.props.row[key];
      }
      return val;
    }, _this2.isContextMenuDisplayed = function () {
      if (_this2.props.cellMetaData) {
        var selected = _this2.props.cellMetaData.selected;
        if (selected && selected.contextMenuDisplayed && selected.rowIdx === _this2.props.idx) {
          return true;
        }
      }
      return false;
    }, _this2.getExpandableOptions = function (columnKey) {
      var subRowDetails = _this2.props.subRowDetails;
      if (subRowDetails) {
        return { canExpand: subRowDetails && subRowDetails.field === columnKey && (subRowDetails.children && subRowDetails.children.length > 0 || subRowDetails.group === true), field: subRowDetails.field, expanded: subRowDetails && subRowDetails.expanded, children: subRowDetails && subRowDetails.children, treeDepth: subRowDetails ? subRowDetails.treeDepth : 0, subRowDetails: subRowDetails };
      }
      return {};
    }, _this2.setScrollLeft = function (scrollLeft) {
      _this2.props.columns.forEach(function (column) {
        if (column.locked) {
          if (!_this2[column.key]) return;
          _this2[column.key].setScrollLeft(scrollLeft);
        }
      });
    }, _this2.getKnownDivProps = function () {
      return createObjectWithProperties(_this2.props, knownDivPropertyKeys);
    }, _this2.renderCell = function (props) {
      if (typeof _this2.props.cellRenderer === 'function') {
        _this2.props.cellRenderer.call(_this2, props);
      }
      if (React.isValidElement(_this2.props.cellRenderer)) {
        return React.cloneElement(_this2.props.cellRenderer, props);
      }

      return _this2.props.cellRenderer(props);
    }, _temp), _possibleConstructorReturn(_this2, _ret);
  }

  _createClass(Row, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return (0, _RowComparer2['default'])(nextProps, this.props);
    }
  }, {
    key: 'render',
    value: function render() {
      var className = joinClasses('react-grid-Row', 'react-grid-Row--' + (this.props.idx % 2 === 0 ? 'even' : 'odd'), {
        'row-selected': this.props.isSelected,
        'row-context-menu': this.isContextMenuDisplayed()
      }, this.props.extraClasses);

      var style = {
        height: this.getRowHeight(this.props),
        overflow: 'hidden',
        contain: 'layout'
      };

      var cells = this.getCells();
      return React.createElement(
        'div',
        _extends({}, this.getKnownDivProps(), { className: className, style: style, onDragEnter: this.handleDragEnter }),
        React.isValidElement(this.props.row) ? this.props.row : cells
      );
    }
  }]);

  return Row;
}(React.Component), _class.displayName = 'Row', _class.defaultProps = {
  cellRenderer: Cell,
  isSelected: false,
  height: 35
}, _temp2);
Row.propTypes = process.env.NODE_ENV !== "production" ? {
  height: _propTypes2['default'].number.isRequired,
  columns: _propTypes2['default'].oneOfType([_propTypes2['default'].object, _propTypes2['default'].array]).isRequired,
  row: _propTypes2['default'].any.isRequired,
  cellRenderer: _propTypes2['default'].func,
  cellMetaData: _propTypes2['default'].shape(cellMetaDataShape),
  isSelected: _propTypes2['default'].bool,
  idx: _propTypes2['default'].number.isRequired,
  expandedRows: _propTypes2['default'].arrayOf(_propTypes2['default'].object),
  extraClasses: _propTypes2['default'].string,
  forceUpdate: _propTypes2['default'].bool,
  subRowDetails: _propTypes2['default'].object,
  isRowHovered: _propTypes2['default'].bool,
  colVisibleStart: _propTypes2['default'].number.isRequired,
  colVisibleEnd: _propTypes2['default'].number.isRequired,
  colDisplayStart: _propTypes2['default'].number.isRequired,
  colDisplayEnd: _propTypes2['default'].number.isRequired,
  isScrolling: _propTypes2['default'].bool.isRequired
} : {};


module.exports = Row;