'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var ExcelColumn = require('../../PropTypeShapes/ExcelColumn');

var FilterableHeaderCell = function (_React$Component) {
  _inherits(FilterableHeaderCell, _React$Component);

  function FilterableHeaderCell() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, FilterableHeaderCell);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FilterableHeaderCell.__proto__ || Object.getPrototypeOf(FilterableHeaderCell)).call.apply(_ref, [this].concat(args))), _this), _this.state = { filterTerm: '' }, _this.handleChange = function (e) {
      var val = e.target.value;
      _this.setState({ filterTerm: val });
      _this.props.onChange({ filterTerm: val, column: _this.props.column });
    }, _this.renderInput = function () {
      if (_this.props.column.filterable === false) {
        return React.createElement('span', null);
      }

      var inputKey = 'header-filter-' + _this.props.column.key;
      return React.createElement('input', { key: inputKey, type: 'text', className: 'form-control input-sm', placeholder: 'Search', value: _this.state.filterTerm, onChange: _this.handleChange });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(FilterableHeaderCell, [{
    key: 'render',
    value: function render() {
      return React.createElement(
        'div',
        null,
        React.createElement(
          'div',
          { className: 'form-group' },
          this.renderInput()
        )
      );
    }
  }]);

  return FilterableHeaderCell;
}(React.Component);

FilterableHeaderCell.propTypes = process.env.NODE_ENV !== "production" ? {
  onChange: _propTypes2['default'].func.isRequired,
  column: _propTypes2['default'].shape(ExcelColumn)
} : {};


module.exports = FilterableHeaderCell;