'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2, _initialiseProps;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _keyboardUtils = require('../utils/keyboardUtils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');

var joinClasses = require('classnames');
var SimpleTextEditor = require('./SimpleTextEditor');
var isFunction = require('../utils/isFunction');


require('.././themes/react-data-grid-core.css');

var EditorContainer = (_temp2 = _class = function (_React$Component) {
  _inherits(EditorContainer, _React$Component);

  function EditorContainer() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, EditorContainer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = EditorContainer.__proto__ || Object.getPrototypeOf(EditorContainer)).call.apply(_ref, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(EditorContainer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var inputNode = this.getInputNode();
      if (inputNode !== undefined) {
        this.setTextInputFocus();
        if (!this.getEditor().disableContainerStyles) {
          inputNode.className += ' editor-main';
          inputNode.style.height = this.props.height - 1 + 'px';
        }
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (!this.changeCommitted && !this.changeCanceled) {
        this.commit({ key: 'Enter' });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        'div',
        { className: this.getContainerClass(), onBlur: this.handleBlur, onKeyDown: this.onKeyDown, onContextMenu: this.handleRightClick },
        this.createEditor(),
        this.renderStatusIcon()
      );
    }
  }]);

  return EditorContainer;
}(React.Component), _class.displayName = 'EditorContainer', _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.state = { isInvalid: false };
  this.changeCommitted = false;
  this.changeCanceled = false;

  this.isKeyExplicitlyHandled = function (key) {
    return isFunction(_this2['onPress' + key]);
  };

  this.checkAndCall = function (methodName, args) {
    if (isFunction(_this2[methodName])) {
      _this2[methodName](args);
    }
  };

  this.onKeyDown = function (e) {
    if ((0, _keyboardUtils.isCtrlKeyHeldDown)(e)) {
      _this2.checkAndCall('onPressKeyWithCtrl', e);
    } else if (_this2.isKeyExplicitlyHandled(e.key)) {
      // break up individual keyPress events to have their own specific callbacks
      var callBack = 'onPress' + e.key;
      _this2.checkAndCall(callBack, e);
    } else if ((0, _keyboardUtils.isKeyPrintable)(e.keyCode)) {
      _this2.checkAndCall('onPressChar', e);
    }

    // Track which keys are currently down for shift clicking etc
    _this2._keysDown = _this2._keysDown || {};
    _this2._keysDown[e.keyCode] = true;
    if (isFunction(_this2.props.onGridKeyDown)) {
      _this2.props.onGridKeyDown(e);
    }
  };

  this.createEditorRef = function (ref) {
    _this2.editor = ref;
  };

  this.createEditor = function () {
    var editorProps = {
      ref: _this2.createEditorRef,
      column: _this2.props.column,
      value: _this2.getInitialValue(),
      onCommit: _this2.commit,
      onCommitCancel: _this2.commitCancel,
      rowMetaData: _this2.getRowMetaData(),
      rowData: _this2.props.rowData,
      height: _this2.props.height,
      onBlur: _this2.commit,
      onOverrideKeyDown: _this2.onKeyDown
    };

    var CustomEditor = _this2.props.column.editor;
    // return custom column editor or SimpleEditor if none specified
    if (React.isValidElement(CustomEditor)) {
      return React.cloneElement(CustomEditor, editorProps);
    }
    if (isFunction(CustomEditor)) {
      return React.createElement(CustomEditor, _extends({ ref: _this2.createEditorRef }, editorProps));
    }

    return React.createElement(SimpleTextEditor, { ref: _this2.createEditorRef, column: _this2.props.column, value: _this2.getInitialValue(), onBlur: _this2.commit, rowMetaData: _this2.getRowMetaData(), onKeyDown: function onKeyDown() {}, commit: function commit() {} });
  };

  this.onPressEnter = function () {
    _this2.commit({ key: 'Enter' });
  };

  this.onPressTab = function () {
    _this2.commit({ key: 'Tab' });
  };

  this.onPressEscape = function (e) {
    if (!_this2.editorIsSelectOpen()) {
      _this2.commitCancel();
    } else {
      // prevent event from bubbling if editor has results to select
      e.stopPropagation();
    }
  };

  this.onPressArrowDown = function (e) {
    if (_this2.editorHasResults()) {
      // dont want to propogate as that then moves us round the grid
      e.stopPropagation();
    } else {
      _this2.commit(e);
    }
  };

  this.onPressArrowUp = function (e) {
    if (_this2.editorHasResults()) {
      // dont want to propogate as that then moves us round the grid
      e.stopPropagation();
    } else {
      _this2.commit(e);
    }
  };

  this.onPressArrowLeft = function (e) {
    // prevent event propogation. this disables left cell navigation
    if (!_this2.isCaretAtBeginningOfInput()) {
      e.stopPropagation();
    } else {
      _this2.commit(e);
    }
  };

  this.onPressArrowRight = function (e) {
    // prevent event propogation. this disables right cell navigation
    if (!_this2.isCaretAtEndOfInput()) {
      e.stopPropagation();
    } else {
      _this2.commit(e);
    }
  };

  this.editorHasResults = function () {
    if (isFunction(_this2.getEditor().hasResults)) {
      return _this2.getEditor().hasResults();
    }

    return false;
  };

  this.editorIsSelectOpen = function () {
    if (isFunction(_this2.getEditor().isSelectOpen)) {
      return _this2.getEditor().isSelectOpen();
    }

    return false;
  };

  this.getRowMetaData = function () {
    // clone row data so editor cannot actually change this
    // convention based method to get corresponding Id or Name of any Name or Id property
    if (typeof _this2.props.column.getRowMetaData === 'function') {
      return _this2.props.column.getRowMetaData(_this2.props.rowData, _this2.props.column);
    }
  };

  this.getEditor = function () {
    return _this2.editor;
  };

  this.getInputNode = function () {
    return _this2.getEditor().getInputNode();
  };

  this.getInitialValue = function () {
    var selected = _this2.props.cellMetaData.selected;
    var keyCode = selected.initialKeyCode;
    if (keyCode === 'Delete' || keyCode === 'Backspace') {
      return '';
    } else if (keyCode === 'Enter') {
      return _this2.props.value;
    }

    var text = keyCode ? String.fromCharCode(keyCode) : _this2.props.value;
    return text;
  };

  this.getContainerClass = function () {
    return joinClasses({
      'has-error': _this2.state.isInvalid === true
    });
  };

  this.commit = function (args) {
    var opts = args || {};
    var updated = _this2.getEditor().getValue();
    if (_this2.isNewValueValid(updated)) {
      _this2.changeCommitted = true;
      var cellKey = _this2.props.column.key;
      _this2.props.cellMetaData.onCommit({ cellKey: cellKey, rowIdx: _this2.props.rowIdx, updated: updated, key: opts.key });
    }
  };

  this.commitCancel = function () {
    _this2.changeCanceled = true;
    _this2.props.cellMetaData.onCommitCancel();
  };

  this.isNewValueValid = function (value) {
    if (isFunction(_this2.getEditor().validate)) {
      var isValid = _this2.getEditor().validate(value);
      _this2.setState({ isInvalid: !isValid });
      return isValid;
    }

    return true;
  };

  this.setCaretAtEndOfInput = function () {
    var input = _this2.getInputNode();
    // taken from http://stackoverflow.com/questions/511088/use-javascript-to-place-cursor-at-end-of-text-in-text-input-element
    var txtLength = input.value.length;
    if (input.setSelectionRange) {
      input.setSelectionRange(txtLength, txtLength);
    } else if (input.createTextRange) {
      var fieldRange = input.createTextRange();
      fieldRange.moveStart('character', txtLength);
      fieldRange.collapse();
      fieldRange.select();
    }
  };

  this.isCaretAtBeginningOfInput = function () {
    var inputNode = _this2.getInputNode();
    return inputNode.selectionStart === inputNode.selectionEnd && inputNode.selectionStart === 0;
  };

  this.isCaretAtEndOfInput = function () {
    var inputNode = _this2.getInputNode();
    return inputNode.selectionStart === inputNode.value.length;
  };

  this.isBodyClicked = function (e) {
    var relatedTarget = _this2.getRelatedTarget(e);
    return relatedTarget === null;
  };

  this.isViewportClicked = function (e) {
    var relatedTarget = _this2.getRelatedTarget(e);
    return relatedTarget.className.indexOf('react-grid-Viewport') > -1;
  };

  this.isClickInsideEditor = function (e) {
    var relatedTarget = _this2.getRelatedTarget(e);
    return e.currentTarget.contains(relatedTarget) || relatedTarget.className.indexOf('editing') > -1 || relatedTarget.className.indexOf('react-grid-Cell') > -1;
  };

  this.getRelatedTarget = function (e) {
    return e.relatedTarget || e.explicitOriginalTarget || document.activeElement; // IE11
  };

  this.handleRightClick = function (e) {
    e.stopPropagation();
  };

  this.handleBlur = function (e) {
    e.stopPropagation();
    if (_this2.isBodyClicked(e)) {
      _this2.commit(e);
    }

    if (!_this2.isBodyClicked(e)) {
      // prevent null reference
      if (_this2.isViewportClicked(e) || !_this2.isClickInsideEditor(e)) {
        _this2.commit(e);
      }
    }
  };

  this.setTextInputFocus = function () {
    var selected = _this2.props.cellMetaData.selected;
    var keyCode = selected.initialKeyCode;
    var inputNode = _this2.getInputNode();
    inputNode.focus();
    if (inputNode.tagName === 'INPUT') {
      if (!(0, _keyboardUtils.isKeyPrintable)(keyCode)) {
        inputNode.focus();
        inputNode.select();
      } else {
        inputNode.select();
      }
    }
  };

  this.renderStatusIcon = function () {
    if (_this2.state.isInvalid === true) {
      return React.createElement('span', { className: 'glyphicon glyphicon-remove form-control-feedback' });
    }
  };
}, _temp2);
EditorContainer.propTypes = process.env.NODE_ENV !== "production" ? {
  rowIdx: _propTypes2['default'].number,
  rowData: _propTypes2['default'].object.isRequired,
  value: _propTypes2['default'].oneOfType([_propTypes2['default'].string, _propTypes2['default'].number, _propTypes2['default'].object, _propTypes2['default'].bool]).isRequired,
  cellMetaData: _propTypes2['default'].shape({
    selected: _propTypes2['default'].object.isRequired,
    copied: _propTypes2['default'].object,
    dragged: _propTypes2['default'].object,
    onCellClick: _propTypes2['default'].func,
    onCellDoubleClick: _propTypes2['default'].func,
    onCommitCancel: _propTypes2['default'].func,
    onCommit: _propTypes2['default'].func
  }).isRequired,
  column: _propTypes2['default'].object.isRequired,
  height: _propTypes2['default'].number.isRequired,
  onGridKeyDown: _propTypes2['default'].func
} : {};


module.exports = EditorContainer;