'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _CellActionShape = require('./PropTypeShapes/CellActionShape');

var _CellActionShape2 = _interopRequireDefault(_CellActionShape);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CellAction = function (_React$Component) {
  _inherits(CellAction, _React$Component);

  function CellAction() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, CellAction);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = CellAction.__proto__ || Object.getPrototypeOf(CellAction)).call.apply(_ref, [this].concat(args))), _this), _this.state = { isMenuOpen: false }, _this.onToggleMenu = function () {
      _this.setState(function (prevState) {
        return { isMenuOpen: !prevState.isMenuOpen };
      });
    }, _this.onHideMenu = function () {
      _this.setState({ isMenuOpen: false });
    }, _this.onGetMenuOptions = function () {
      return _this.props.action.actions.map(function (action, index) {
        return _react2['default'].createElement(
          'span',
          { key: index, onClick: action.callback },
          action.text
        );
      });
    }, _this.isActionMenu = function () {
      return !_this.props.action.callback && _this.props.action.actions && _this.props.action.actions.length;
    }, _this.onActionButtonBlur = function () {
      if (_this.isActionMenu()) {
        _this.onHideMenu();
      }
    }, _this.onActionIconClick = function () {
      if (!_this.isActionMenu()) {
        _this.props.action.callback();
      } else if (_this.props.action.actions && _this.props.action.actions.length) {
        _this.onToggleMenu();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(CellAction, [{
    key: 'render',
    value: function render() {
      var isActionMenu = this.isActionMenu();

      var cellActionClasses = (0, _classnames2['default'])('rdg-cell-action', {
        'rdg-cell-action-last': this.props.isFirst
      });

      var actionButtonClasses = (0, _classnames2['default'])('rdg-cell-action-button', {
        'rdg-cell-action-button-toggled': this.state.isMenuOpen
      });

      return _react2['default'].createElement(
        'div',
        { className: cellActionClasses, onMouseLeave: this.onActionButtonBlur },
        _react2['default'].createElement(
          'div',
          { className: actionButtonClasses, onClick: this.onActionIconClick },
          _react2['default'].createElement('span', { className: this.props.action.icon })
        ),
        isActionMenu && this.state.isMenuOpen && _react2['default'].createElement(
          'div',
          { className: 'rdg-cell-action-menu' },
          this.onGetMenuOptions()
        )
      );
    }
  }]);

  return CellAction;
}(_react2['default'].Component);

CellAction.propTypes = process.env.NODE_ENV !== "production" ? {
  action: _propTypes2['default'].shape(_CellActionShape2['default']).isRequired,
  isFirst: _propTypes2['default'].bool.isRequired
} : {};
exports['default'] = CellAction;
module.exports = exports['default'];