'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');

var createObjectWithProperties = require('./createObjectWithProperties');
require('./themes/react-data-grid-header.css');

// The list of the propTypes that we want to include in the Draggable div
var knownDivPropertyKeys = ['onDragStart', 'onDragEnd', 'onDrag', 'style'];

var Draggable = (_temp2 = _class = function (_React$Component) {
  _inherits(Draggable, _React$Component);

  function Draggable() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Draggable);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Draggable.__proto__ || Object.getPrototypeOf(Draggable)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      drag: null
    }, _this.onMouseDown = function (e) {
      var drag = _this.props.onDragStart(e);
      if (e.preventDefault) {
        e.preventDefault();
      }

      if (drag === null && e.button !== 0) {
        return;
      }

      window.addEventListener('mouseup', _this.onMouseUp);
      window.addEventListener('mousemove', _this.onMouseMove);
      window.addEventListener('touchend', _this.onMouseUp);
      window.addEventListener('touchmove', _this.onMouseMove);

      _this.setState({ drag: drag });
    }, _this.onMouseMove = function (e) {
      if (_this.state.drag === null) {
        return;
      }

      if (e.preventDefault) {
        e.preventDefault();
      }

      _this.props.onDrag(e);
    }, _this.onMouseUp = function (e) {
      _this.cleanUp();
      if (_this._mounted === true) {
        _this.props.onDragEnd(e, _this.state.drag);
      }
    }, _this.cleanUp = function () {
      window.removeEventListener('mouseup', _this.onMouseUp);
      window.removeEventListener('mousemove', _this.onMouseMove);
      window.removeEventListener('touchend', _this.onMouseUp);
      window.removeEventListener('touchmove', _this.onMouseMove);
    }, _this.getKnownDivProps = function () {
      return createObjectWithProperties(_this.props, knownDivPropertyKeys);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Draggable, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this._mounted = false;
      this.cleanUp();
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._mounted = true;
      this.setState({ drag: null });
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement('div', _extends({}, this.getKnownDivProps(), {
        onMouseDown: this.onMouseDown,
        onTouchStart: this.onMouseDown,
        className: 'react-grid-HeaderCell__draggable' }));
    }
  }]);

  return Draggable;
}(React.Component), _class.defaultProps = {
  onDragStart: function onDragStart() {
    return true;
  },
  onDragEnd: function onDragEnd() {},
  onDrag: function onDrag() {}
}, _temp2);
Draggable.propTypes = process.env.NODE_ENV !== "production" ? {
  onDragStart: _propTypes2['default'].func,
  onDragEnd: _propTypes2['default'].func,
  onDrag: _propTypes2['default'].func,
  component: _propTypes2['default'].oneOfType([_propTypes2['default'].func, _propTypes2['default'].constructor]),
  style: _propTypes2['default'].object
} : {};


module.exports = Draggable;