'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ColumnUtils = require('./ColumnUtils');

var _ColumnUtils2 = _interopRequireDefault(_ColumnUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EmptyChildRow = function (_React$Component) {
  _inherits(EmptyChildRow, _React$Component);

  function EmptyChildRow() {
    _classCallCheck(this, EmptyChildRow);

    var _this = _possibleConstructorReturn(this, (EmptyChildRow.__proto__ || Object.getPrototypeOf(EmptyChildRow)).call(this));

    _this.onAddSubRow = _this.onAddSubRow.bind(_this);
    return _this;
  }

  _createClass(EmptyChildRow, [{
    key: 'onAddSubRow',
    value: function onAddSubRow() {
      this.props.onAddSubRow(this.props.parentRowId);
    }
  }, {
    key: 'getFixedColumnsWidth',
    value: function getFixedColumnsWidth() {
      var fixedWidth = 0;
      var size = _ColumnUtils2['default'].getSize(this.props.columns);
      for (var i = 0; i < size; i++) {
        var column = _ColumnUtils2['default'].getColumn(this.props.columns, i);
        if (column) {
          if (_ColumnUtils2['default'].getValue(column, 'locked')) {
            fixedWidth += _ColumnUtils2['default'].getValue(column, 'width');
          }
        }
      }
      return fixedWidth;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          cellHeight = _props.cellHeight,
          treeDepth = _props.treeDepth;

      var height = 12;
      var width = 12;
      var left = treeDepth * 15;
      var top = (cellHeight - 12) / 2;
      var style = {
        height: cellHeight,
        borderBottom: '1px solid #dddddd'
      };
      var expandColumn = _ColumnUtils2['default'].getColumn(this.props.columns.filter(function (c) {
        return c.key === _this2.props.expandColumnKey;
      }), 0);

      var cellLeft = expandColumn ? expandColumn.left : 0;
      return _react2['default'].createElement(
        'div',
        { className: 'react-grid-Row rdg-add-child-row-container', style: style },
        _react2['default'].createElement(
          'div',
          { className: 'react-grid-Cell', style: { position: 'absolute', height: cellHeight, width: '100%', left: cellLeft } },
          _react2['default'].createElement(
            'div',
            { className: 'rdg-empty-child-row', style: { marginLeft: '30px', lineHeight: cellHeight + 'px' } },
            _react2['default'].createElement('div', { className: '\'rdg-child-row-action-cross rdg-child-row-action-cross-last' }),
            _react2['default'].createElement(
              'div',
              { style: { left: left, top: top, width: width, height: height }, className: 'rdg-child-row-btn', onClick: this.onAddSubRow },
              _react2['default'].createElement('div', { className: 'glyphicon glyphicon-plus-sign' })
            )
          )
        )
      );
    }
  }]);

  return EmptyChildRow;
}(_react2['default'].Component);

EmptyChildRow.propTypes = process.env.NODE_ENV !== "production" ? {
  treeDepth: _propTypes2['default'].number.isRequired,
  cellHeight: _propTypes2['default'].number.isRequired,
  onAddSubRow: _propTypes2['default'].func.isRequired,
  parentRowId: _propTypes2['default'].number,
  columns: _propTypes2['default'].array.isRequired,
  expandColumnKey: _propTypes2['default'].string.isRequired
} : {};

exports['default'] = EmptyChildRow;
module.exports = exports['default'];