'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var ReactDOM = require('react-dom');
var joinClasses = require('classnames');
var shallowCloneObject = require('./shallowCloneObject');
var ColumnMetrics = require('./ColumnMetrics');
var ColumnUtils = require('./ColumnUtils');
var HeaderRow = require('./HeaderRow');
var getScrollbarSize = require('./getScrollbarSize');


var createObjectWithProperties = require('./createObjectWithProperties');
var cellMetaDataShape = require('./PropTypeShapes/CellMetaDataShape');
var SortDataShape = require('./PropTypeShapes/SortDataShape');
var areSortArraysEqual = require('./utils/areSortArraysEqual');
require('./themes/react-data-grid-header.css');

// The list of the propTypes that we want to include in the Header div
var knownDivPropertyKeys = ['height', 'onScroll'];

var Header = function (_React$Component) {
  _inherits(Header, _React$Component);

  function Header() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Header);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Header.__proto__ || Object.getPrototypeOf(Header)).call.apply(_ref, [this].concat(args))), _this), _this.state = { resizing: null, appliedFilters: null }, _this.setAppliedFilters = function (filters) {
      _this.setState({ appliedFilters: filters });
    }, _this.onColumnResize = function (column, width) {
      var state = _this.state.resizing || _this.props;

      var pos = _this.getColumnPosition(column);

      if (pos != null) {
        var _resizing = {
          columnMetrics: shallowCloneObject(state.columnMetrics)
        };
        _resizing.columnMetrics = ColumnMetrics.resizeColumn(_resizing.columnMetrics, pos, width);

        // we don't want to influence scrollLeft while resizing
        if (_resizing.columnMetrics.totalWidth < state.columnMetrics.totalWidth) {
          _resizing.columnMetrics.totalWidth = state.columnMetrics.totalWidth;
        }

        _resizing.column = ColumnUtils.getColumn(_resizing.columnMetrics.columns, pos);
        _this.setState({ resizing: _resizing });
      }
    }, _this.onColumnResizeEnd = function (column, width) {
      var pos = _this.getColumnPosition(column);
      /*if(this.props.columnMetrics.width-width<=this.props.columnMetrics.totalWidth){
        //this.props.columnMetrics.columns[this.props.columnMetrics.columns.length-1].width=this.props.columnMetrics.totalWidth-this.props.columnMetrics.width+width;
        this.props.onColumnResize(this.getColumnPosition(this.props.columnMetrics.columns[this.props.columnMetrics.columns.length-1]), this.props.columnMetrics.totalWidth-this.props.columnMetrics.width+width);
      }*/
      console.info(_this.props.columnMetrics);
      if (pos !== null && _this.props.onColumnResize) {
        _this.props.onColumnResize(pos, width || column.width, _this.props.columnMetrics.width);
      }
    }, _this.getHeaderRows = function () {
      var columnMetrics = _this.getColumnMetrics();
      var resizeColumn = void 0;
      if (_this.state.resizing) {
        resizeColumn = _this.state.resizing.column;
      }
      var headerRows = [];
      /*this.props.headerRows.forEach((row, index) => {
        // To allow header filters to be visible
        let rowHeight = '500px';
        let scrollbarSize = getScrollbarSize() > 0 ? getScrollbarSize() : 0;
        let updatedWidth = isNaN(this.props.totalWidth - scrollbarSize) ? this.props.totalWidth : this.props.totalWidth - scrollbarSize;
        let headerRowStyle = {
          position: 'absolute',
          top: this.getCombinedHeaderHeights(index),
          left: 0,
          width: updatedWidth,
          overflowX: 'hidden',
          minHeight: rowHeight
        };
         headerRows.push(<HeaderRow
          key={row.ref}
          rowType={'filter'}
          style={headerRowStyle}
          onColumnResize={this.onColumnResize}
          onColumnResizeEnd={this.onColumnResizeEnd}
          width={columnMetrics.width}
          height={row.height || this.props.height}
          columns={columnMetrics.columns}
          resizing={resizeColumn}
          draggableHeaderCell={this.props.draggableHeaderCell}
          filterable={row.filterable}
          onFilterChange={row.onFilterChange}
          onHeaderDrop={this.props.onHeaderDrop}
          sortColumn={this.props.sortColumn}
          sortDirection={this.props.sortDirection}
          sort={this.props.sort}
          onSort={this.props.onSort}
          onScroll={this.props.onScroll}
          getValidFilterValues={this.props.getValidFilterValues}
          appliedFilters={this.state.appliedFilters}
          showFilterCallback={this.props.showFilterCallback}
        />);
      });*/
      _this.props.headerRows.forEach(function (row, index) {
        // To allow header filters to be visible
        var rowHeight = 'auto';
        if (row.rowType === 'filter') {
          rowHeight = '500px';
        }
        var scrollbarSize = getScrollbarSize() > 0 ? getScrollbarSize() : 0;
        //let updatedWidth = isNaN(this.props.totalWidth - scrollbarSize) ? this.props.totalWidth : this.props.totalWidth - scrollbarSize;
        var updatedWidth = _this.props.totalWidth;
        var headerRowStyle = {
          position: 'absolute',
          top: _this.getCombinedHeaderHeights(index),
          left: 0,
          width: updatedWidth,
          overflowX: 'hidden',
          minHeight: rowHeight
        };

        headerRows.push(React.createElement(HeaderRow, {
          key: row.ref,
          ref: function ref(node) {
            return row.rowType === 'filter' ? _this.filterRow = node : _this.row = node;
          },
          rowType: row.rowType,
          style: headerRowStyle,
          onColumnResize: _this.onColumnResize,
          onColumnResizeEnd: _this.onColumnResizeEnd,
          width: columnMetrics.width,
          height: row.height || _this.props.height,
          columns: columnMetrics.columns,
          resizing: resizeColumn,
          draggableHeaderCell: _this.props.draggableHeaderCell,
          filterable: row.filterable,
          onFilterChange: row.onFilterChange,
          onHeaderDrop: _this.props.onHeaderDrop,
          sortColumn: _this.props.sortColumn,
          sortDirection: _this.props.sortDirection,
          sort: _this.props.sort,
          onSort: _this.props.onSort,
          onScroll: _this.props.onScroll,
          getValidFilterValues: _this.props.getValidFilterValues,
          appliedFilters: _this.state.appliedFilters,
          showFilterCallback: _this.props.showFilterCallback
        }));
      });
      return headerRows;
    }, _this.getColumnMetrics = function () {
      var columnMetrics = void 0;
      if (_this.state.resizing) {
        columnMetrics = _this.state.resizing.columnMetrics;
      } else {
        columnMetrics = _this.props.columnMetrics;
      }
      return columnMetrics;
    }, _this.getColumnPosition = function (column) {
      var columnMetrics = _this.getColumnMetrics();
      var pos = -1;
      columnMetrics.columns.forEach(function (c, idx) {
        if (c.key === column.key) {
          pos = idx;
        }
      });
      return pos === -1 ? null : pos;
    }, _this.getCombinedHeaderHeights = function (until) {
      var stopAt = _this.props.headerRows.length;
      if (typeof until !== 'undefined') {
        stopAt = until;
      }

      var height = 0;
      for (var index = 0; index < stopAt; index++) {
        height += _this.props.headerRows[index].height || _this.props.height;
      }
      return height;
    }, _this.getStyle = function () {
      return {
        position: 'relative',
        height: _this.getCombinedHeaderHeights()
      };
    }, _this.setScrollLeft = function (scrollLeft) {
      var node = ReactDOM.findDOMNode(_this.row);
      node.scrollLeft = scrollLeft;
      _this.row.setScrollLeft(scrollLeft);
      if (_this.filterRow) {
        var nodeFilters = ReactDOM.findDOMNode(_this.filterRow);
        nodeFilters.scrollLeft = scrollLeft;
        _this.filterRow.setScrollLeft(scrollLeft);
      }
    }, _this.getKnownDivProps = function () {
      return createObjectWithProperties(_this.props, knownDivPropertyKeys);
    }, _this.onHeaderClick = function () {
      _this.props.cellMetaData.onCellClick({ rowIdx: -1, idx: -1 });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Header, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps() {
      this.setState({ resizing: null });
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var update = !ColumnMetrics.sameColumns(this.props.columnMetrics.columns, nextProps.columnMetrics.columns, ColumnMetrics.sameColumn) || this.props.totalWidth !== nextProps.totalWidth || this.props.headerRows.length !== nextProps.headerRows.length || this.state.resizing !== nextState.resizing || this.state.appliedFilters !== nextState.appliedFilters || !areSortArraysEqual(nextProps.sort, this.props.sort) || this.props.sortColumn !== nextProps.sortColumn || this.props.sortDirection !== nextProps.sortDirection;
      return update;
    }

    // Set the cell selection to -1 x -1 when clicking on the header

  }, {
    key: 'render',
    value: function render() {
      var className = joinClasses({
        'react-grid-Header': true,
        'react-grid-Header--resizing': !!this.state.resizing
      });
      var headerRows = this.getHeaderRows();

      return React.createElement(
        'div',
        _extends({}, this.getKnownDivProps(), { style: this.getStyle(), className: className, onClick: this.onHeaderClick }),
        headerRows
      );
    }
  }]);

  return Header;
}(React.Component);

Header.propTypes = process.env.NODE_ENV !== "production" ? {
  columnMetrics: _propTypes2['default'].shape({ width: _propTypes2['default'].number.isRequired, columns: _propTypes2['default'].any }).isRequired,
  totalWidth: _propTypes2['default'].oneOfType([_propTypes2['default'].number, _propTypes2['default'].string]),
  height: _propTypes2['default'].number.isRequired,
  headerRows: _propTypes2['default'].array.isRequired,
  sortColumn: _propTypes2['default'].string,
  sortDirection: _propTypes2['default'].oneOf(['ASC', 'DESC', 'NONE']),
  sort: SortDataShape,
  onSort: _propTypes2['default'].func,
  onColumnResize: _propTypes2['default'].func,
  onScroll: _propTypes2['default'].func,
  onHeaderDrop: _propTypes2['default'].func,
  draggableHeaderCell: _propTypes2['default'].func,
  getValidFilterValues: _propTypes2['default'].func,
  cellMetaData: _propTypes2['default'].shape(cellMetaDataShape),
  //{"owner":"jsfja"}
  showFilterCallback: _propTypes2['default'].func.isRequired
} : {};


module.exports = Header;