'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var ReactDOM = require('react-dom');
var joinClasses = require('classnames');
var ExcelColumn = require('./PropTypeShapes/ExcelColumn');
var ResizeHandle = require('./ResizeHandle');
require('./themes/react-data-grid-header.css');

function simpleCellRenderer(objArgs) {
    var headerText = objArgs.column.rowType === 'header' ? objArgs.column.name : '';
    return React.createElement(
        'div',
        { className: 'widget-HeaderCell__value' },
        headerText
    );
}

var HeaderCell = (_temp2 = _class = function (_React$Component) {
    _inherits(HeaderCell, _React$Component);

    function HeaderCell() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, HeaderCell);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = HeaderCell.__proto__ || Object.getPrototypeOf(HeaderCell)).call.apply(_ref, [this].concat(args))), _this), _this.state = { resizing: false }, _this.onDragStart = function (e) {
            _this.setState({ resizing: true });
            // need to set dummy data for FF
            if (e && e.dataTransfer && e.dataTransfer.setData) e.dataTransfer.setData('text/plain', 'dummy');
        }, _this.onDrag = function (e) {
            var resize = _this.props.onResize || null; // for flows sake, doesnt recognise a null check direct
            if (resize) {
                var _width = _this.getWidthFromMouseEvent(e);
                if (_width > 0) {
                    resize(_this.props.column, _width);
                }
            }
        }, _this.showHideFilter = function () {
            if (_this.props.showFilterCallback != null) {
                _this.props.showFilterCallback(_this.props.column);
            } else {
                console.info('no callback on filter show for column', _this.props.column);
            }
        }, _this.onDragEnd = function (e) {
            var width = _this.getWidthFromMouseEvent(e);
            if (width > 95) {
                _this.props.onResizeEnd(_this.props.column, width);
                if (_this._mounted === true) {
                    _this.setState({ resizing: false });
                }
            } else {
                _this.props.onResizeEnd(_this.props.column, 95);
                if (_this._mounted === true) {
                    _this.setState({ resizing: false });
                }
            }
        }, _this.getWidthFromMouseEvent = function (e) {
            var right = e.pageX || e.touches && e.touches[0] && e.touches[0].pageX || e.changedTouches && e.changedTouches[e.changedTouches.length - 1].pageX;
            var left = ReactDOM.findDOMNode(_this).getBoundingClientRect().left;
            return right - left;
        }, _this.getCell = function () {
            if (React.isValidElement(_this.props.renderer)) {
                // if it is a string, it's an HTML element, and column is not a valid property, so only pass height
                if (typeof _this.props.renderer.type === 'string') {
                    return React.cloneElement(_this.props.renderer, { height: _this.props.height });
                }
                return React.cloneElement(_this.props.renderer, { column: _this.props.column, height: _this.props.height });
            }
            return _this.props.renderer({ column: _this.props.column });
        }, _this.getStyle = function () {
            return {
                width: _this.props.column.width,
                left: _this.props.column.left,
                display: 'inline-block',
                position: 'absolute',
                height: _this.props.height - 30,
                marginTop: '30px',
                textOverflow: 'ellipsis',
                whiteSpace: 'nowrap'
            };
        }, _this.setScrollLeft = function (scrollLeft) {
            var node = ReactDOM.findDOMNode(_this);
            node.style.webkitTransform = 'translate3d(' + scrollLeft + 'px, 0px, 0px)';
            node.style.transform = 'translate3d(' + scrollLeft + 'px, 0px, 0px)';
        }, _this.removeScroll = function () {
            var node = ReactDOM.findDOMNode(_this);
            if (node) {
                var transform = 'none';
                node.style.webkitTransform = transform;
                node.style.transform = transform;
            }
        }, _this.dropFilter = function () {
            _this.props.column.dropFilter(_this.props.column);
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(HeaderCell, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this._mounted = true;
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this._mounted = false;
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var resizeHandle = void 0;
            if (this.props.column.resizable) {
                resizeHandle = React.createElement(ResizeHandle, {
                    onDrag: this.onDrag,
                    onDragStart: this.onDragStart,
                    onDragEnd: this.onDragEnd
                });
            }

            var className = joinClasses({
                'react-grid-HeaderCell': true,
                'react-grid-HeaderCell--resizing': this.state.resizing,
                'react-grid-HeaderCell--locked': this.props.column.locked,
                'filter-set': this.props.isFilterSet === true
            });
            className = joinClasses(className, this.props.className, this.props.column.cellClass);
            //this.props.column.sortable = this.props.canFilter;

            var cell = this.getCell();
            var fil = this.props.height - 30;
            var getFilterValueFunc = function getFilterValueFunc(val) {
                if (_this2.props.column.filterHeaderFormatter == null) {
                    return val.filterTerm;
                }
                return _this2.props.column.filterHeaderFormatter(val);
            };
            var fVal = void 0;
            if (this.props.isFilterSet) {
                if (this.props.column.filterCannotBeRemoved === true) {
                    fVal = React.createElement(
                        'div',
                        { className: 'react-grid-Header__filtred', style: { marginTop: '-20px' } },
                        'getFilterValueFunc(this.props.filterValue);'
                    );
                } else {
                    fVal = React.createElement(
                        'div',
                        { className: 'react-grid-Header__filtred', style: { marginTop: '-20px' } },
                        getFilterValueFunc(this.props.filterValue),
                        (this.props.column.filterCannotBeRemoved == null || this.props.column.filterCannotBeRemoved == false) && React.createElement(
                            'button',
                            { className: 'react-grid-Header__filtred-cancel', onClick: this.dropFilter },
                            '\xD7'
                        )
                    );
                }
            }
            return React.createElement(
                'div',
                { className: className, style: this.getStyle() },
                React.createElement(
                    'div',
                    { style: { width: this.props.column.width, height: this.props.height - 30 },
                        className: 'header-cell-wrapper' },
                    cell,
                    this.props.column.filterable && (this.props.canFilter || this.props.column.filterFirst) && React.createElement(
                        'button',
                        { type: 'button', onClick: this.showHideFilter,
                            className: this.props.column.filterClass ? this.props.column.filterClass : 'react-grid-Header__filter-btn' },
                        React.createElement(
                            'svg',
                            { width: '16', height: '16', viewBox: '0 0 16 16', fill: 'none', xmlns: 'http://www.w3.org/2000/svg' },
                            React.createElement('path', { opacity: '0.3', d: 'M6.27001 15.51C6.04001 15.51 5.82001 15.46 5.60001 15.35C5.09001 15.1 4.78001 14.59 4.78001 14.02V6.89L0.180014 1.94C-0.0599864 1.55 -0.0699864 1.05 0.150014 0.65C0.370014 0.25 0.810014 0 1.27001 0H14.3C14.76 0 15.18 0.25 15.41 0.65C15.63 1.05 15.63 1.55 15.39 1.94L15.26 2.1L10.78 6.9V11.76C10.78 12.22 10.56 12.67 10.19 12.95L7.16001 15.22C6.90001 15.41 6.59001 15.51 6.27001 15.51ZM2.95001 2L6.78001 6.11V13L8.78001 11.5V6.11L12.62 2H2.95001Z', fill: '#434244' })
                        )
                    )
                ),
                this.props.isFilterSet && React.createElement(
                    'div',
                    { className: 'react-grid-Header__filtred', style: { marginTop: '-23px' } },
                    getFilterValueFunc(this.props.filterValue),
                    (this.props.column.filterCannotBeRemoved == null || this.props.column.filterCannotBeRemoved == false) && React.createElement(
                        'button',
                        { className: 'react-grid-Header__filtred-cancel', onClick: this.dropFilter },
                        '\xD7'
                    )
                ),
                resizeHandle
            );
        }
    }]);

    return HeaderCell;
}(React.Component), _class.defaultProps = {
    renderer: simpleCellRenderer
}, _temp2);
HeaderCell.propTypes = process.env.NODE_ENV !== "production" ? {
    renderer: _propTypes2['default'].oneOfType([_propTypes2['default'].func, _propTypes2['default'].element]).isRequired,
    column: _propTypes2['default'].shape(ExcelColumn).isRequired,
    onResize: _propTypes2['default'].func.isRequired,
    height: _propTypes2['default'].number.isRequired,
    onResizeEnd: _propTypes2['default'].func.isRequired,
    className: _propTypes2['default'].string,
    //show is filter set
    isFilterSet: _propTypes2['default'].bool.isRequired,
    filterValue: _propTypes2['default'].oneOfType([_propTypes2['default'].object, _propTypes2['default'].string]),
    //can filter on this column
    canFilter: _propTypes2['default'].bool.isRequired,
    //call show/hide filter window
    showFilterCallback: _propTypes2['default'].func.isRequired
} : {};


module.exports = HeaderCell;