'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LEFT_PAGE = 'LEFT';
var RIGHT_PAGE = 'RIGHT';
var ELLIPSIS_PAGE = 'ELLIPSIS';

var range = function range(from, to) {
    var step = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;

    var i = from;
    var range = [];

    while (i <= to) {
        range.push(i);
        i += step;
    }

    return range;
};

var Pagination = (_temp = _class = function (_Component) {
    _inherits(Pagination, _Component);

    function Pagination(props) {
        _classCallCheck(this, Pagination);

        var _this = _possibleConstructorReturn(this, (Pagination.__proto__ || Object.getPrototypeOf(Pagination)).call(this, props));

        _initialiseProps.call(_this);

        var _props$pageLimit = props.pageLimit,
            pageLimit = _props$pageLimit === undefined ? 30 : _props$pageLimit,
            _props$pageNeighbours = props.pageNeighbours,
            pageNeighbours = _props$pageNeighbours === undefined ? 0 : _props$pageNeighbours,
            _props$ellipsis = props.ellipsis,
            ellipsis = _props$ellipsis === undefined ? false : _props$ellipsis;


        _this.ellipsis = ellipsis == null ? false : ellipsis;
        _this.pageLimit = typeof pageLimit === 'number' ? pageLimit : 30;

        _this.pageNeighbours = typeof pageNeighbours === 'number' ? Math.max(0, pageNeighbours) : 0;

        _this.totalPages = _this.props.totalPages < 10 ? _this.props.totalPages - 1 : _this.props.totalPages;

        _this.state = { currentPage: 1 };
        return _this;
    }

    _createClass(Pagination, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (isNaN(this.props.currentPage)) {
                this.gotoPage(1);
            } else {
                this.gotoPage(this.props.currentPage);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var currentPage = this.state.currentPage;

            var pages = this.fetchPageNumbers();

            return _react2['default'].createElement(
                _react.Fragment,
                null,
                _react2['default'].createElement(
                    'nav',
                    { style: { display: 'inline-block', marginLeft: '200px' }, 'aria-label': 'Countries Pagination' },
                    _react2['default'].createElement(
                        'ul',
                        { className: 'pagination', style: { width: 'auto' } },
                        pages.map(function (page, index) {
                            if (page === LEFT_PAGE) {
                                return _react2['default'].createElement(
                                    'li',
                                    { key: index, className: 'page-item' },
                                    _react2['default'].createElement(
                                        'a',
                                        { style: { height: '100%' }, className: 'page-link', href: '#', 'aria-label': 'Previous', onClick: _this2.handleMoveLeft },
                                        _react2['default'].createElement('span', { style: {
                                                border: 'solid black',
                                                borderWidth: '0 2px 2px 0',
                                                display: 'inline-block',
                                                padding: '3px',
                                                position: 'relative',
                                                top: '-1px',
                                                left: '2px',
                                                transform: 'rotate(135deg)' }, 'aria-hidden': 'true' }),
                                        _react2['default'].createElement(
                                            'span',
                                            { className: 'sr-only' },
                                            'Previous'
                                        )
                                    )
                                );
                            }

                            if (page === RIGHT_PAGE) {
                                return _react2['default'].createElement(
                                    'li',
                                    { key: index, className: 'page-item' },
                                    _react2['default'].createElement(
                                        'a',
                                        { style: { height: '100%' }, className: 'page-link', href: '#', 'aria-label': 'Next', onClick: _this2.handleMoveRight },
                                        _react2['default'].createElement('span', { style: {
                                                border: 'solid black',
                                                borderWidth: '0 2px 2px 0',
                                                display: 'inline-block',
                                                padding: '3px',
                                                position: 'relative',
                                                top: '-1px',
                                                left: '-1px',
                                                transform: 'rotate(-45deg)' }, 'aria-hidden': 'true' }),
                                        _react2['default'].createElement(
                                            'span',
                                            { className: 'sr-only' },
                                            'Next'
                                        )
                                    )
                                );
                            }

                            if (page === ELLIPSIS_PAGE) {
                                return _react2['default'].createElement(
                                    'li',
                                    { key: index, className: 'page-item' },
                                    _react2['default'].createElement(
                                        'a',
                                        { className: 'page-link', href: '#', 'aria-label': 'More', onClick: _this2.handleMoveMoreRight },
                                        _react2['default'].createElement(
                                            'span',
                                            { 'aria-hidden': 'true' },
                                            '...'
                                        ),
                                        _react2['default'].createElement(
                                            'span',
                                            { className: 'sr-only' },
                                            'More'
                                        )
                                    )
                                );
                            }

                            return _react2['default'].createElement(
                                'li',
                                { key: index, className: 'page-item' + (currentPage === page ? ' active' : '') },
                                _react2['default'].createElement(
                                    'a',
                                    { className: 'page-link', href: '#', onClick: function onClick(e) {
                                            return _this2.handleClick(page, e);
                                        } },
                                    page
                                )
                            );
                        })
                    )
                )
            );
        }
    }]);

    return Pagination;
}(_react.Component), _initialiseProps = function _initialiseProps() {
    var _this3 = this;

    this.gotoPage = function (page) {
        var _props$onPageChanged = _this3.props.onPageChanged,
            onPageChanged = _props$onPageChanged === undefined ? function (f) {
            return f;
        } : _props$onPageChanged;


        var currentPage = Math.max(0, Math.min(page, _this3.props.totalPages));

        var paginationData = {
            currentPage: currentPage,
            totalPages: _this3.props.totalPages < 10 ? _this3.props.totalPages - 1 : _this3.props.totalPages,
            pageLimit: _this3.pageLimit
        };

        _this3.setState({ currentPage: currentPage }, function () {
            return onPageChanged(paginationData);
        });
        console.log(paginationData);
    };

    this.handleClick = function (page, evt) {
        evt.preventDefault();
        _this3.gotoPage(page);
    };

    this.handleMoveLeft = function (evt) {
        evt.preventDefault();
        _this3.gotoPage(_this3.state.currentPage - 1);
    };

    this.handleMoveRight = function (evt) {
        evt.preventDefault();
        _this3.gotoPage(_this3.state.currentPage + 1);
    };

    this._endPage = 10;

    this.handleMoveMoreRight = function (evt) {
        evt.preventDefault();
        _this3.gotoPage(_this3._endPage + 1);
    };

    this.fetchPageNumbers = function () {
        var totalPages = _this3.props.totalPages < 10 ? _this3.props.totalPages - 1 : _this3.props.totalPages;
        var currentPage = _this3.state.currentPage;
        var pageNeighbours = _this3.pageNeighbours;

        var totalNumbers = _this3.pageNeighbours * 2 + 2;
        var totalBlocks = totalNumbers + 3;

        if (totalPages > totalBlocks) {
            var pages = [];

            var leftBound = currentPage - pageNeighbours;
            var rightBound = currentPage + pageNeighbours;
            var beforeLastPage = totalPages - 1;

            var startPage = leftBound > 2 ? leftBound : 2;
            var endPage = rightBound < beforeLastPage ? rightBound : beforeLastPage;

            pages = range(startPage, endPage);

            var pagesCount = pages.length;
            var singleSpillOffset = totalNumbers - pagesCount - 1;

            var leftSpill = startPage > 3;
            if (startPage === 3) pages = [2].concat(_toConsumableArray(pages));
            var rightSpill = endPage < beforeLastPage;

            var leftSpillPage = LEFT_PAGE;
            var rightSpillPage = RIGHT_PAGE;
            var ellipsisSpillPage = ELLIPSIS_PAGE;

            if (leftSpill && !rightSpill) {
                var extraPages = range(startPage - singleSpillOffset, startPage - 1);
                pages = [leftSpillPage].concat(_toConsumableArray(extraPages), _toConsumableArray(pages));
            } else if (!leftSpill && rightSpill) {
                var _extraPages = range(endPage + 1, endPage + singleSpillOffset);
                _this3._endPage = _extraPages[_extraPages.length - 1] || 10;
                pages = [].concat(_toConsumableArray(pages), _toConsumableArray(_extraPages), [rightSpillPage]);
            } else if (leftSpill && rightSpill) {
                _this3._endPage = pages[pages.length - 1] || 10;
                pages = [leftSpillPage].concat(_toConsumableArray(pages), [rightSpillPage]);
            }

            if (!_this3.ellipsis) {
                return [1].concat(_toConsumableArray(pages), [totalPages]);
            } else {
                if (rightSpill) {
                    return [1].concat(_toConsumableArray(pages), [ellipsisSpillPage]);
                } else {
                    return [1].concat(_toConsumableArray(pages));
                }
            }
        }
        return range(1, totalPages);
    };
}, _temp);
exports['default'] = Pagination;
module.exports = exports['default'];