'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

require('./themes/react-data-grid-row.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var cellMetaDataShape = require('./PropTypeShapes/CellMetaDataShape');

var RowGroup = function (_Component) {
  _inherits(RowGroup, _Component);

  function RowGroup(props) {
    _classCallCheck(this, RowGroup);

    var _this = _possibleConstructorReturn(this, (RowGroup.__proto__ || Object.getPrototypeOf(RowGroup)).call(this, props));

    _this.onRowExpandToggle = _this.onRowExpandToggle.bind(_this);
    _this.onRowExpandClick = _this.onRowExpandClick.bind(_this);
    _this.setScrollLeft = _this.setScrollLeft.bind(_this);
    return _this;
  }

  _createClass(RowGroup, [{
    key: 'onRowExpandToggle',
    value: function onRowExpandToggle(expand) {
      var shouldExpand = expand == null ? !this.props.isExpanded : expand;
      var meta = this.props.cellMetaData;
      if (meta != null && meta.onRowExpandToggle && typeof meta.onRowExpandToggle === 'function') {
        meta.onRowExpandToggle({ rowIdx: this.props.idx, shouldExpand: shouldExpand, columnGroupName: this.props.columnGroupName, name: this.props.name });
      }
    }
  }, {
    key: 'onRowExpandClick',
    value: function onRowExpandClick() {
      this.onRowExpandToggle(!this.props.isExpanded);
    }
  }, {
    key: 'setScrollLeft',
    value: function setScrollLeft(scrollLeft) {
      if (this.rowGroupRenderer) {
        this.rowGroupRenderer.setScrollLeft ? this.rowGroupRenderer.setScrollLeft(scrollLeft) : null;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var lastColumn = _utils2['default'].last(this.props.columns);

      var style = lastColumn ? { width: lastColumn.left + lastColumn.width } : { width: 0 };

      return _react2['default'].createElement(
        'div',
        { style: style, className: 'react-grid-row-group' },
        _react2['default'].createElement(this.props.renderer, _extends({ ref: function ref(node) {
            _this2.rowGroupRenderer = node;
          } }, this.props, { onRowExpandClick: this.onRowExpandClick, onRowExpandToggle: this.onRowExpandToggle }))
      );
    }
  }]);

  return RowGroup;
}(_react.Component);

RowGroup.propTypes = process.env.NODE_ENV !== "production" ? {
  height: _propTypes2['default'].number.isRequired,
  columns: _propTypes2['default'].oneOfType([_propTypes2['default'].object, _propTypes2['default'].array]).isRequired,
  row: _propTypes2['default'].any.isRequired,
  cellRenderer: _propTypes2['default'].func,
  cellMetaData: _propTypes2['default'].shape(cellMetaDataShape),
  isSelected: _propTypes2['default'].bool,
  idx: _propTypes2['default'].number.isRequired,
  expandedRows: _propTypes2['default'].arrayOf(_propTypes2['default'].object),
  extraClasses: _propTypes2['default'].string,
  forceUpdate: _propTypes2['default'].bool,
  subRowDetails: _propTypes2['default'].object,
  isRowHovered: _propTypes2['default'].bool,
  colVisibleStart: _propTypes2['default'].number.isRequired,
  colVisibleEnd: _propTypes2['default'].number.isRequired,
  colDisplayStart: _propTypes2['default'].number.isRequired,
  colDisplayEnd: _propTypes2['default'].number.isRequired,
  isScrolling: _propTypes2['default'].bool.isRequired,
  columnGroupName: _propTypes2['default'].string.isRequired,
  isExpanded: _propTypes2['default'].bool.isRequired,
  treeDepth: _propTypes2['default'].number.isRequired,
  name: _propTypes2['default'].string.isRequired,
  renderer: _propTypes2['default'].func
} : {};

var DefaultRowGroupRenderer = function DefaultRowGroupRenderer(props) {
  var treeDepth = props.treeDepth || 0;
  var marginLeft = treeDepth * 20;

  var style = {
    height: '50px',
    border: '1px solid #dddddd',
    paddingTop: '15px',
    paddingLeft: '5px'
  };

  var onKeyDown = function onKeyDown(e) {
    if (e.key === 'ArrowLeft') {
      props.onRowExpandToggle(false);
    }
    if (e.key === 'ArrowRight') {
      props.onRowExpandToggle(true);
    }
    if (e.key === 'Enter') {
      props.onRowExpandToggle(!props.isExpanded);
    }
  };
  return _react2['default'].createElement(
    'div',
    { style: style, onKeyDown: onKeyDown, tabIndex: 0 },
    _react2['default'].createElement(
      'span',
      { className: 'row-expand-icon', style: { float: 'left', marginLeft: marginLeft, cursor: 'pointer' }, onClick: props.onRowExpandClick },
      props.isExpanded ? String.fromCharCode('9660') : String.fromCharCode('9658')
    ),
    _react2['default'].createElement(
      'strong',
      null,
      props.columnGroupName,
      ': ',
      props.name
    )
  );
};

DefaultRowGroupRenderer.propTypes = process.env.NODE_ENV !== "production" ? {
  onRowExpandClick: _propTypes2['default'].func.isRequired,
  onRowExpandToggle: _propTypes2['default'].func.isRequired,
  isExpanded: _propTypes2['default'].bool.isRequired,
  treeDepth: _propTypes2['default'].number.isRequired,
  name: _propTypes2['default'].string.isRequired,
  columnGroupName: _propTypes2['default'].string.isRequired,
  hideColumnName: _propTypes2['default'].bool
} : {};

RowGroup.defaultProps = {
  renderer: DefaultRowGroupRenderer
};

exports['default'] = RowGroup;
module.exports = exports['default'];