'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.SimpleRowsContainer = exports.getNewContextMenuProps = exports.DEFAULT_CONTEXT_MENU_ID = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_CONTEXT_MENU_ID = exports.DEFAULT_CONTEXT_MENU_ID = 'rgdContextMenu';

var SimpleRowsContainer = function SimpleRowsContainer(props) {
    return _react2['default'].createElement(
        'div',
        { key: 'rows-container', style: { width: props.width } },
        props.rows
    );
};

SimpleRowsContainer.propTypes = process.env.NODE_ENV !== "production" ? {
    width: _propTypes2['default'].number,
    rows: _propTypes2['default'].array
} : {};

var getNewContextMenuProps = exports.getNewContextMenuProps = function getNewContextMenuProps(_ref) {
    var contextMenu = _ref.contextMenu,
        rowIdx = _ref.rowIdx,
        idx = _ref.idx;
    return {
        rowIdx: rowIdx, idx: idx, id: contextMenu.props.id || DEFAULT_CONTEXT_MENU_ID
    };
};

var RowsContainer = function (_React$Component) {
    _inherits(RowsContainer, _React$Component);

    function RowsContainer(props) {
        _classCallCheck(this, RowsContainer);

        var _this = _possibleConstructorReturn(this, (RowsContainer.__proto__ || Object.getPrototypeOf(RowsContainer)).call(this, props));

        _this.plugins = props.window ? props.window.ReactDataGridPlugins : window.ReactDataGridPlugins;
        return _this;
    }

    _createClass(RowsContainer, [{
        key: 'validatePlugin',
        value: function validatePlugin() {
            if (!this.plugins) {
                throw new Error('You need to include ReactDataGrid UiPlugins in order to initialise context menu');
            }
        }
    }, {
        key: 'hasContextMenu',
        value: function hasContextMenu() {
            return this.props.contextMenu && _react2['default'].isValidElement(this.props.contextMenu);
        }
    }, {
        key: 'renderRowsWithContextMenu',
        value: function renderRowsWithContextMenu() {
            var ContextMenuTrigger = this.plugins.Menu.ContextMenuTrigger;

            var newProps = getNewContextMenuProps(this.props);
            var contextMenu = _react2['default'].cloneElement(this.props.contextMenu, newProps);
            // Initialise the context menu if it is available
            return _react2['default'].createElement(
                'div',
                null,
                _react2['default'].createElement(
                    ContextMenuTrigger,
                    { id: newProps.id },
                    _react2['default'].createElement(
                        'div',
                        { key: 'rows-container', style: { width: this.props.width } },
                        this.props.rows
                    )
                ),
                contextMenu
            );
        }
    }, {
        key: 'render',
        value: function render() {
            if (this.hasContextMenu()) {
                this.validatePlugin();
                return this.renderRowsWithContextMenu();
            }

            return _react2['default'].createElement(
                'div',
                { key: 'rows-container', style: { width: this.props.width, height: '100px' } },
                this.props.rows
            );
        }
    }]);

    return RowsContainer;
}(_react2['default'].Component);

RowsContainer.propTypes = process.env.NODE_ENV !== "production" ? {
    contextMenu: _propTypes2['default'].element,
    rowIdx: _propTypes2['default'].number,
    idx: _propTypes2['default'].number,
    window: _propTypes2['default'].object,
    columns: _propTypes2['default'].oneOfType([_propTypes2['default'].object, _propTypes2['default'].array]).isRequired
} : {};

exports['default'] = RowsContainer;
exports.SimpleRowsContainer = SimpleRowsContainer;