'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ColumnUtils = require('./ColumnUtils');

var _ColumnUtils2 = _interopRequireDefault(_ColumnUtils);

var _viewportUtils = require('./utils/viewportUtils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var Canvas = require('./Canvas');
var cellMetaDataShape = require('./PropTypeShapes/CellMetaDataShape');
var Viewport = (_temp2 = _class = function (_React$Component) {
    _inherits(Viewport, _React$Component);

    function Viewport() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Viewport);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Viewport.__proto__ || Object.getPrototypeOf(Viewport)).call.apply(_ref, [this].concat(args))), _this), _this.state = (0, _viewportUtils.getGridState)(_this.props), _this.filterRefsCollection = {}, _this.showFilter = function (column) {
            var val = _this.filterRefsCollection[column.key];
            var _thisref = _this;
            Object.keys(_this.filterRefsCollection).forEach(function (key) {
                try {
                    _thisref.filterRefsCollection[key].hide();
                } catch (e) {}
            });

            if (val != undefined) {
                val.show();
            }
        }, _this.onScroll = function (scroll) {
            _this.updateScroll(scroll.scrollTop, scroll.scrollLeft, _this.state.height, _this.props.rowHeight, _this.props.rowsCount);

            if (_this.props.onScroll) {
                _this.props.onScroll({ scrollTop: scroll.scrollTop, scrollLeft: scroll.scrollLeft });
            }
        }, _this.getScroll = function () {
            return _this.canvas.getScroll();
        }, _this.setScrollLeft = function (scrollLeft) {
            if (_this.canvas) {
                _this.canvas.setScrollLeft(scrollLeft);
            }
        }, _this.getDOMNodeOffsetWidth = function () {
            return _this.viewport ? _this.viewport.offsetWidth : 0;
        }, _this.clearScrollTimer = function () {
            if (_this.resetScrollStateTimeoutId) {
                clearTimeout(_this.resetScrollStateTimeoutId);
            }
        }, _this.resetScrollStateAfterDelay = function () {
            _this.clearScrollTimer();
            _this.resetScrollStateTimeoutId = setTimeout(_this.resetScrollStateAfterDelayCallback, 500);
        }, _this.resetScrollStateAfterDelayCallback = function () {
            /*this.resetScrollStateTimeoutId = null;
            this.setState({
              isScrolling: false
            });*/

        }, _this.updateScroll = function (scrollTop, scrollLeft, height, rowHeight, length, width) {
            _this.resetScrollStateAfterDelay();
            var nextScrollState = (0, _viewportUtils.getNextScrollState)(_this.props, _this.getDOMNodeOffsetWidth, scrollTop, scrollLeft, height, rowHeight, length, width);

            _this.setState(nextScrollState);
        }, _this.metricsUpdated = function () {
            var height = _this.viewportHeight();
            var width = _this.viewportWidth();
            if (height) {
                _this.updateScroll(_this.state.scrollTop, _this.state.scrollLeft, height, _this.props.rowHeight, _this.props.rowsCount, width);
            }
        }, _this.viewportHeight = function () {
            return _this.viewport ? _this.viewport.offsetHeight : 0;
        }, _this.viewportWidth = function () {
            return _this.viewport ? _this.viewport.offsetWidth : 0;
        }, _this.addFilterRef = function (refF, column) {
            _this.filterRefsCollection[column.key] = refF;
        }, _this.scrollToTop = function () {
            /*this.updateScroll(
              0,
              this.state.scrollLeft,
              this.state.height,
              this.props.rowHeight,
              this.props.rowsCount
            );*/
            _this.canvas.scrollToTop();
        }, _this.onClick = function (e) {
            console.info('onclieck', e.target, e.nativeEvent);
        }, _this.renderLoading = function () {
            if (!_this.props.dataReady && _this.props.loadingElementRender) {
                return _this.props.loadingElementRender(_this.props.totalWidth);
            }
            return React.createElement('div', null);
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Viewport, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (this.props.rowHeight !== nextProps.rowHeight || this.props.minHeight !== nextProps.minHeight) {
                var newState = (0, _viewportUtils.getGridState)(nextProps);
                this.updateScroll(newState.scrollTop, newState.scrollLeft, newState.height, nextProps.rowHeight, nextProps.rowsCount);
            } else if (_ColumnUtils2['default'].getSize(this.props.columnMetrics.columns) !== _ColumnUtils2['default'].getSize(nextProps.columnMetrics.columns)) {
                this.setState((0, _viewportUtils.getGridState)(nextProps));
            } else if (this.props.rowsCount !== nextProps.rowsCount) {
                this.updateScroll(this.state.scrollTop, this.state.scrollLeft, this.state.height, nextProps.rowHeight, nextProps.rowsCount);
                // Added to fix the hiding of the bottom scrollbar when showing the filters.
            } else if (this.props.rowOffsetHeight !== nextProps.rowOffsetHeight) {
                // The value of height can be positive or negative and will be added to the current height to cater for changes in the header height (due to the filer)
                var height = this.props.rowOffsetHeight - nextProps.rowOffsetHeight;

                this.updateScroll(this.state.scrollTop, this.state.scrollLeft, this.state.height + height, nextProps.rowHeight, nextProps.rowsCount);
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (window.addEventListener) {
                window.addEventListener('resize', this.metricsUpdated);
            } else {
                window.attachEvent('resize', this.metricsUpdated);
            }
            this.metricsUpdated();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            window.removeEventListener('resize', this.metricsUpdated);
            this.clearScrollTimer();
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var style = {
                padding: 0,
                bottom: 0,
                left: 0,
                right: 0,
                //overflow: 'hidden',
                position: 'absolute',
                top: this.props.rowOffsetHeight
            };
            return React.createElement(
                'div',
                {
                    className: 'react-grid-Viewport',
                    style: style,
                    ref: function ref(node) {
                        _this2.viewport = node;
                    } },
                React.createElement(
                    'div',
                    { style: { position: 'absolute', zIndex: 100 } },
                    this.props.columnMetrics.columns.map(function (r, idx) {
                        if (r.filterComponent) {
                            var filterWidth = r.filterWidth ? r.filterWidth : 300;
                            var left = r.left - _this2.state.scrollLeft + r.width;
                            if (left - filterWidth < 0) {
                                left = filterWidth + 10 - _this2.state.scrollLeft;
                            }
                            return React.createElement(
                                'div',
                                { key: idx, style: {
                                        position: 'absolute',
                                        left: left - filterWidth
                                    } },
                                r.filterComponent(r, _this2.addFilterRef)
                            );
                        } else {
                            return React.createElement('div', { key: idx, style: { position: 'absolute', left: r.left } });
                        }
                    })
                ),
                this.renderLoading(),
                React.createElement('div', { className: 'header-cell-border', style: {
                        position: 'absolute',
                        zIndex: 100,
                        top: -this.props.headerHeight + 30,
                        right: '1px',
                        width: '8px',
                        height: this.props.headerHeight - 30,
                        background: '#e5e5e5',
                        borderRadius: '4px'
                    } }),
                React.createElement(Canvas, {
                    ref: function ref(node) {
                        return _this2.canvas = node;
                    },
                    rowKey: this.props.rowKey,
                    totalWidth: this.props.totalWidth,
                    width: this.props.columnMetrics.width,
                    rowGetter: this.props.rowGetter,
                    rowsCount: this.props.rowsCount,
                    selectedRows: this.props.selectedRows,
                    expandedRows: this.props.expandedRows,
                    columns: this.props.columnMetrics.columns,
                    rowRenderer: this.props.rowRenderer,
                    displayStart: this.state.displayStart,
                    displayEnd: this.state.displayEnd,
                    visibleStart: this.state.visibleStart,
                    visibleEnd: this.state.visibleEnd,
                    colVisibleStart: this.state.colVisibleStart,
                    colVisibleEnd: this.state.colVisibleEnd,
                    colDisplayStart: this.state.colDisplayStart,
                    colDisplayEnd: this.state.colDisplayEnd,
                    cellMetaData: this.props.cellMetaData,
                    height: this.state.height,
                    rowHeight: this.props.rowHeight,
                    onScroll: this.onScroll,
                    onRows: this.props.onRows,
                    rowScrollTimeout: this.props.rowScrollTimeout,
                    scrollToRowIndex: this.props.scrollToRowIndex,
                    contextMenu: this.props.contextMenu,
                    rowSelection: this.props.rowSelection,
                    getSubRowDetails: this.props.getSubRowDetails,
                    rowGroupRenderer: this.props.rowGroupRenderer,
                    isScrolling: this.state.isScrolling || false
                })
            );
        }
    }]);

    return Viewport;
}(React.Component), _class.displayName = 'Viewport', _class.defaultProps = {
    rowHeight: 30
}, _temp2);
Viewport.propTypes = process.env.NODE_ENV !== "production" ? {
    rowOffsetHeight: _propTypes2['default'].number.isRequired,
    totalWidth: _propTypes2['default'].oneOfType([_propTypes2['default'].number, _propTypes2['default'].string]).isRequired,
    columnMetrics: _propTypes2['default'].object.isRequired,
    rowGetter: _propTypes2['default'].oneOfType([_propTypes2['default'].array, _propTypes2['default'].func]).isRequired,
    selectedRows: _propTypes2['default'].array,
    rowSelection: _propTypes2['default'].oneOfType([_propTypes2['default'].shape({
        indexes: _propTypes2['default'].arrayOf(_propTypes2['default'].number).isRequired
    }), _propTypes2['default'].shape({
        isSelectedKey: _propTypes2['default'].string.isRequired
    }), _propTypes2['default'].shape({
        keys: _propTypes2['default'].shape({
            values: _propTypes2['default'].array.isRequired,
            rowKey: _propTypes2['default'].string.isRequired
        }).isRequired
    })]),
    expandedRows: _propTypes2['default'].array,
    rowRenderer: _propTypes2['default'].oneOfType([_propTypes2['default'].element, _propTypes2['default'].func]),
    rowsCount: _propTypes2['default'].number.isRequired,
    rowHeight: _propTypes2['default'].number.isRequired,
    onRows: _propTypes2['default'].func,
    onScroll: _propTypes2['default'].func,
    minHeight: _propTypes2['default'].number,
    cellMetaData: _propTypes2['default'].shape(cellMetaDataShape),
    rowKey: _propTypes2['default'].string.isRequired,
    rowScrollTimeout: _propTypes2['default'].number,
    scrollToRowIndex: _propTypes2['default'].number,
    contextMenu: _propTypes2['default'].element,
    getSubRowDetails: _propTypes2['default'].func,
    rowGroupRenderer: _propTypes2['default'].func,
    headerHeight: _propTypes2['default'].number,
    dataReady: _propTypes2['default'].bool
} : {};


module.exports = Viewport;