'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');

var joinClasses = require('classnames');
var DEFINE_SORT = {
  ASC: 'ASC',
  DESC: 'DESC',
  NONE: 'NONE'
};

var SortableHeaderCell = function (_React$Component) {
  _inherits(SortableHeaderCell, _React$Component);

  function SortableHeaderCell() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, SortableHeaderCell);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SortableHeaderCell.__proto__ || Object.getPrototypeOf(SortableHeaderCell)).call.apply(_ref, [this].concat(args))), _this), _this.onClick = function () {
      var direction = void 0;
      var _this$props = _this.props,
          sortDirection = _this$props.sortDirection,
          sortDescendingFirst = _this$props.sortDescendingFirst;

      switch (sortDirection) {
        default:
        case null:
        case undefined:
        case DEFINE_SORT.NONE:
          direction = sortDescendingFirst ? DEFINE_SORT.DESC : DEFINE_SORT.ASC;
          break;
        case DEFINE_SORT.ASC:
          direction = sortDescendingFirst ? DEFINE_SORT.NONE : DEFINE_SORT.DESC;
          break;
        case DEFINE_SORT.DESC:
          direction = sortDescendingFirst ? DEFINE_SORT.ASC : DEFINE_SORT.NONE;
          break;
      }
      _this.props.onSort(_this.props.columnKey, direction);
    }, _this.getSortByText = function () {
      var unicodeKeys = {
        ASC: '9650',
        DESC: '9660'
      };
      return _this.props.sortDirection === 'NONE' ? '' : String.fromCharCode(unicodeKeys[_this.props.sortDirection]);
      //return this.props.sortDirection === 'NONE' ? '' : ('>');
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SortableHeaderCell, [{
    key: 'render',
    value: function render() {
      var className = joinClasses({
        'react-grid-HeaderCell-sortable': true,
        'react-grid-HeaderCell-sortable--ascending': this.props.sortDirection === 'ASC',
        'react-grid-HeaderCell-sortable--descending': this.props.sortDirection === 'DESC'
      });
      var content = this.props.headerRenderer ? this.props.headerRenderer : this.props.column.name;
      return React.createElement(
        'div',
        { className: className,
          onClick: this.onClick,
          style: { cursor: 'pointer' } },
        React.createElement('span', { className: 'pull-right' }),
        content
      );
    }
  }]);

  return SortableHeaderCell;
}(React.Component);

SortableHeaderCell.propTypes = process.env.NODE_ENV !== "production" ? {
  columnKey: _propTypes2['default'].string.isRequired,
  column: _propTypes2['default'].shape({ name: _propTypes2['default'].node }),
  onSort: _propTypes2['default'].func.isRequired,
  sortDirection: _propTypes2['default'].oneOf(Object.keys(DEFINE_SORT)),
  headerRenderer: _propTypes2['default'].node,
  sortDescendingFirst: _propTypes2['default'].bool
} : {};


module.exports = SortableHeaderCell;
module.exports.DEFINE_SORT = DEFINE_SORT;