'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _immutable = require('immutable');

module.exports = {
  isEmptyArray: require('./isEmptyArray'),
  isEmptyObject: require('./isEmptyObject'),
  isFunction: require('./isFunction'),
  isImmutableCollection: require('./isImmutableCollection'),
  getMixedTypeValueRetriever: require('./mixedTypeValueRetriever'),
  isColumnsImmutable: require('./isColumnsImmutable'),
  isImmutableMap: require('./isImmutableMap'),
  last: function last(arrayOrList) {
    if (arrayOrList == null) {
      throw new Error('arrayOrCollection is null');
    }

    if (_immutable.List.isList(arrayOrList)) {
      return arrayOrList.last();
    }

    if (Array.isArray(arrayOrList)) {
      return arrayOrList[arrayOrList.length - 1];
    }

    throw new Error('Cant get last of: ' + (typeof arrayOrList === 'undefined' ? 'undefined' : _typeof(arrayOrList)));
  }
};