const React = require('react');

export default class CheckBoxMenu extends React.Component {

  constructor(props) {
    super(props);
    this.state = {hideColumns: [], values: {}, changes: {}, show: false};
    this.props.columns.forEach(c => this.state.values[c.key] = true);
    this.props.columns.forEach(c => this.state.changes[c.key] = this.onChange);
  }

  onChange = (key) => {
    this.state.values[key] = !this.state.values[key];
    this.props.onColumnChange(this.state.values);
  };
  isColumnHidden= (key)=>{
    for(let i=0;i<this.props.hiddenColumns.length;i++){
      if(this.props.hiddenColumns[i].key===key){
        return true;
      }
    }
    return false;
  }
  render() {
    return (
      <div style={{background: '#eeeeee', width: '200px'}}
           onMouseLeave={() => this.setState({show: false})} onMouseEnter={() => this.setState({show: true})}>
        <div style={{width: '200px', height: '30px', background: '#eeeeee'}} className='btn btn-light btn-small'>Скрыть столбцы</div>
        {this.state.show && this.props.columns.map(c => <div>
          <label style={{marginLeft: '20px'}}>
            <input type='checkbox' name={c.key} checked={this.state.values[c.key]}
                   onChange={() => this.state.changes[c.key](c.key)}/>
            <a style={{marginLeft: '10px'}}>{c.name}</a>
          </label>
        </div>)}
      </div>
    )
  }
}
